function CommentsList(pViewInstance, pDataInstance, pReturnFn){
	var _this_ = this;
    var iView = pViewInstance;
    var iData = pDataInstance;
    var returnFn = pReturnFn;
    var postID = "";
	var bStateChange = false;
	var lastFocus = null;
	
    var nItemPerPage = 3;
    var nCurItem = 0;
    
    var iPage = null;
    var iCommentsFull = new CommentsFull(new CommentsFullView(_document.getElementById("facebookCommentsMoreDiv")), CommentsListReturnFn);
    var iAddComment = new StreamAddComment(new StreamAddCommentData(), AddReturnFn);
    var arrPageData = new Array();
	
	var instanceState = Facebook.Define.None;
	
    // External Interface
    this.open = function(pPostID, pLastFocus, pIDType){
		instanceState = Facebook.Define.Processing;
		bStateChange = false;
		postID = pPostID;
        /* Start Interactive Device */
		iRemoteFB.CommentListPostID  = postID;
		if (pLastFocus) lastFocus = pLastFocus;
		
		Instance.Main.popupHelpNavi();
        Instance.Main.setKeyHandler(keyHandler, "CommentsList");
        iView.show();
        iData.request(pPostID, onLoadData, pIDType);
    }
    
    this.close = function(){
        /* Start Interactive Device */        
        if(iRemoteFB.videoFlag == 1){
			iRemoteFB.openRemote();	
        }
        else if(iRemoteFB.photoFlag == 1){           
			iRemoteFB.openRemote();
        }
        else{
            if (iRemoteFB.ProfilevideoFlag == 1){
				iRemoteFB.openRemote();
             }
             else{
                if (Instance.Frame.getType() == FacebookFrame.Define.ME) {
					//iRemoteFB.onLoadFacebook();
				}
				else{   
                    var makeMenuData = new Array();	
					makeMenuData[0] = {
						identifier : "menuID34",
						type : "custom",
						title : User.name,
						name : FBID_WALL,
						icon : "example/a.png",
						onClick : "action?selectthis=userWall"
					}
					makeMenuData[1] = {
						identifier : "menuID33",
						type : "custom",
						title : User.name,
						name : SID_INFO_CASE,
						icon : "example/a.png",
						onClick : "action?selectthis=userInfo"
					}
					makeMenuData[2] = {
						identifier : "menuID32",
						type : "custom",
						title : User.name,
						name : FBID_PHOTOS,
						icon : "example/a.png",
						onClick : "action?selectthis=userPhotosProfile"
					}
					makeMenuData[3] = {
						identifier : "menuID31",
						type : "custom",
						title : User.name,
						name : SID_VIDEOS,
						icon : "example/a.png",
						onClick : "action?selectthis=userVideosProfile"
					}
					if (checkBrowserVersion()) {
						//jQuery.sfIRemote('menu', makeMenuData);
					}					
                }
            }
         }
         /* End Interactive Device */
		iView.clear();
        iView.hide();
    }
    
    
    // Internal Functions
    function onLoadData(pResult){
		if (instanceState == Facebook.Define.Processing) {
			instanceState = Facebook.Define.None;
		}
		
		if (!pResult || !(pResult instanceof Array)) {
             /* Start Interactive Device */
			iRemoteFB.errormsgPopup(SID_ALERT_NETWORKERROR_MSG);
             /* End Interactive Device */
			Instance.Popup.enter({
                title: FACEBOOK_NAME
				, message: SID_ALERT_NETWORKERROR_MSG
				, buttons: [{ caption: SID_OK, value: true}]
            }, function(){
				returnPrevious(true);
			});
			return;			
		}
		
        var arrCommentsList = pResult;
          /* Start Interactive Device */
        iRemoteFB.commentsStream = arrCommentsList;
        if(checkBrowserVersion()){
            var makeMenuData = "";
            makeMenuData = {
                identifier : "menuID111",
                type : "custom",
                title : SID_COMMENTS,
                name : SID_COMMENTS,
                icon : "example/a.png"
            }
			if (checkBrowserVersion()){
				jQuery.sfIRemote('menu', makeMenuData);	
			}            
            var responseData = new Array();
              responseData[0] = {
                    type : "button",
                    identifier : "btn1",
                    title :	"Add a Comment",
                    onClick : "action?openAddComment="
                }   
                for(i=0;i<iRemoteFB.commentsStream.length;i++){
                 responseData[i+1] = {
                        type : "imagedesc",
                        identifier : "id"+i,
                        title : iRemoteFB.commentsStream[i].name+"\\n" + "[" + Util.getTime(iRemoteFB.commentsStream[i].time) + "]",
                        description : iRemoteFB.commentsStream[i].text,
                        image : iRemoteFB.commentsStream[i].pic_square,
                        onClick : "action?showwall="+iRemoteFB.commentsStream[i].fromid,
                        titlelinebreak : "wrap"
                 }	
                }
				if (checkBrowserVersion()){
					jQuery.sfIRemote("source", responseData, "menuID111");	
				}                           
        }    
           /* End Interactive Device */
        iPage = new Page(arrCommentsList.length, nItemPerPage);
        for (var pageIdx = 0; pageIdx < iPage.getTotalPages(); pageIdx++) {
            arrPageData[pageIdx] = new Array();
            iPage.setCurPage(pageIdx);
            for (var commentIdx = iPage.getStartIdx(); commentIdx <= iPage.getLastIdx(); commentIdx++) {
                arrPageData[pageIdx].push(arrCommentsList[commentIdx]);
            }
        }
        // Reset current item
        iPage.setCurItemIdx(nCurItem);
        iView.update(arrPageData[iPage.getCurPage()],iPage);
        iView.focus(iPage.getCurItemIdx());
    }
    
	 /* Start Interactive Device */
     this.OnLoadDatafromIphone =function() {
         if(checkBrowserVersion()){
            var makeMenuData = "";
            makeMenuData = {
                identifier : "menuID111",
                type : "custom",
                title : SID_COMMENTS,
                name : SID_COMMENTS,
                icon : "example/a.png"
            }
			if (checkBrowserVersion()){
				jQuery.sfIRemote('menu', makeMenuData);
			}          
           
            var responseData = new Array();
            responseData[0] = {
                type : "button",
                identifier : "btn1",
                title :	"Add a Comment",
                onClick : "action?openAddComment="
            }  
            for(i=0;i<iRemoteFB.commentsStream.length;i++){
             responseData[i+1] = {
                    type : "imagedesc",
                    identifier : "id"+i,
                    title : iRemoteFB.commentsStream[i].name+"\\n" + "[" + Util.getTime(iRemoteFB.commentsStream[i].time) + "]",
                    description : iRemoteFB.commentsStream[i].text,
                    image : iRemoteFB.commentsStream[i].pic_square,
                    onClick : "action?showwall="+iRemoteFB.commentsStream[i].fromid,
                    titlelinebreak : "wrap"
             }	
            }
			if (checkBrowserVersion()){
				jQuery.sfIRemote("source", responseData, "menuID111");
			}                           
         }	 	    
     }
      /* End Interactive Device */
     this.getiData = function(){
    return iData;
    }
     /*
     *END
     */
    function returnPrevious(pUpdate){
		_this_.close();
        returnFn(pUpdate ? pUpdate : bStateChange, lastFocus ? lastFocus : null);
    }
    
    function keyHandler(pKeyCode){
		if (instanceState == Facebook.Define.Processing) {
			FBTrace("CommentsList : Processing (Block Key Event)");
			return;
		}
        switch (pKeyCode) {
            case TV.KEY_RIGHT:
            case TV.KEY_PANEL_VOL_DOWN:
                break;
            case TV.KEY_LEFT:
            case TV.KEY_PANEL_VOL_UP:
                break;
            case TV.KEY_UP:
            case TV.KEY_WHEELUP:
            case TV.KEY_PANEL_CH_UP:
                iView.blur(iPage.getIdxInPage());
                var itemIdx = (iPage.getCurItemIdx() > 0) ? (iPage.getCurItemIdx() - 1) : (iPage.getTotalItems() - 1);
                if (iPage.setCurItemIdx(itemIdx)) {
                    iView.update(arrPageData[iPage.getCurPage()],iPage);
                }
                iView.focus(iPage.getIdxInPage());
                break;
            case TV.KEY_DOWN:
            case TV.KEY_WHEELDOWN:
            case TV.KEY_PANEL_CH_DOWN:
                iView.blur(iPage.getIdxInPage());
                var itemIdx = (iPage.getCurItemIdx() < (iPage.getTotalItems() - 1)) ? (iPage.getCurItemIdx() + 1) : 0;
                if (iPage.setCurItemIdx(itemIdx)) {
                    iView.update(arrPageData[iPage.getCurPage()],iPage);
                }
                iView.focus(iPage.getIdxInPage());
                break;
            case TV.KEY_ENTER:
				// No matter contents length, show full text popup
//                if (iView.needFull(iPage.getIdxInPage())) {
					iView.hide();
                    iCommentsFull.open(arrPageData[iPage.getCurPage()][iPage.getIdxInPage()],canDelete());
//                }
                break;
			case TV.KEY_RETURN:
				returnPrevious();
				break;
			case TV.KEY_BLUE:
				iRemoteFB.ProfilevideoFlag = 0;
				_this_.close();
				returnFn(Facebook.Define.Close);
				Instance.Frame.open(arrPageData[iPage.getCurPage()][iPage.getIdxInPage()].fromid,Facebook.Define.Menu.WALL);
//				Instance.Frame.open(arrPageData[iPage.getCurPage()][iPage.getIdxInPage()].fromid);
				break;				
			case TV.KEY_GREEN:
				instanceState = Facebook.Define.Processing;
				iView.hide();
				iAddComment.enter(postID);
				break;
            default:
                break;
        }
    }
	
	function canDelete() {
		var strWritter = arrPageData[iPage.getCurPage()][iPage.getIdxInPage()].fromid;
		var strStreamOwner = arrPageData[iPage.getCurPage()][iPage.getIdxInPage()].post_id.split('_')[0];
		var strSessionUser = Instance.Main.getLoginID();
		
		if (strWritter == strSessionUser || strStreamOwner == strSessionUser) {
			return true;
		} else {
			return false;
		}
	}
	
	function DeleteReturnFn(pReturnValue) {
       	if (pReturnValue) {
			instanceState = Facebook.Define.Processing;
			iData.del(pReturnValue.id, DeleteComplete);
		} else {
			iView.show();
		}
	}

	function AddReturnFn(pEvent) {
       	if (pEvent == Facebook.Define.Success) {
			iView.clear();
			iView.show();
			iData.request(postID, onLoadData);
			bStateChange = true;
		} else {
			instanceState = Facebook.Define.None;
			iView.show();
			ICommentList.OnLoadDatafromIphone();
		}
	}
	
	this.addReturnFn = function(){
    	AddReturnFn();
	}
	
	IAddComment = iAddComment;

	function DeleteComplete(pEvent) {
		if (pEvent == Facebook.Define.Success) {
			//Success to delete comment
			iView.clear();
			_this_.open(postID);
			bStateChange = true;
		} else if (pEvent == Facebook.Define.Fail) {
			// Fail to delete comment
			iRemoteFB.errormsgPopup(SID_ALERT_NETWORKERROR_MSG);
			Instance.Popup.enter({
                title: FACEBOOK_NAME,
                message: SID_ALERT_NETWORKERROR_MSG,
                buttons: [{ caption: SID_OK, value: true}]
            }, function(){
				_this_.open(postID);
				bStateChange = false;
			});
		}
	}
	
	function CommentsListReturnFn(pReturn, pArgs) {
		FBTrace("CommentsList :: CommentsListReturnFn");
        Instance.Main.setKeyHandler(keyHandler, "CommentsList");
		switch(pReturn) {
			case Facebook.Define.Delete :
				instanceState = Facebook.Define.Processing;
				iData.del(pArgs, DeleteComplete);
				break;
			case Facebook.Define.Close :
				_this_.close();
				returnFn(Facebook.Define.Close);
				break;
			default :
				iView.show();
				iView.refresh();
				iView.focus(iPage.getIdxInPage());
				break;
		}
	}
}
