function CommentsListData() {
    var completeFn = null;
    
    this.request = function(pID, pCompleteFn, pIDType){
		Instance.Loading.open();
        completeFn = pCompleteFn;
        var strMultiQuery = "";
		if (pIDType == Facebook.Define.IDTYPE_OBJECT) {
			strMultiQuery = '{\"comments\": \"SELECT id, post_id, fromid, text, time FROM comment WHERE object_id =\''+pID+'\'" ,\"profile\" : \"SELECT uid, name, pic_square FROM user WHERE uid IN (SELECT fromid FROM #comments)\"}';	
		} else {
			strMultiQuery = '{\"comments\": \"SELECT id, post_id, fromid, text, time FROM comment WHERE post_id =\''+pID+'\'" ,\"profile\" : \"SELECT uid, name, pic_square FROM user WHERE uid IN (SELECT fromid FROM #comments)\"}';
		}
        Instance.API.fql.multiquery(function(pXMLHttpRequest){
            CommentsOnComplete(pXMLHttpRequest);
        }, Instance.API.createAPIParams({
            queries: strMultiQuery,
            format: "JSON"
        }));
        
    }
	/* Start Interactive Device */
     this.requestfromiPhone = function(pID, pCompleteFn, pIDType){
		PostID = pPostID;
		Instance.Loading.open();
        iRemoteFB.showLoading("Loading Data");
		
        completeFn = pCompleteFn;
        var strMultiQuery = "";
		
		if (pIDType == Facebook.Define.IDTYPE_OBJECT) {
			strMultiQuery = '{\"comments\": \"SELECT id, post_id, fromid, text, time FROM comment WHERE object_id =\''+pID+'\'" ,\"profile\" : \"SELECT uid, name, pic_square FROM user WHERE uid IN (SELECT fromid FROM #comments)\"}';	
		} else {
			strMultiQuery = '{\"comments\": \"SELECT id, post_id, fromid, text, time FROM comment WHERE post_id =\''+pID+'\'" ,\"profile\" : \"SELECT uid, name, pic_square FROM user WHERE uid IN (SELECT fromid FROM #comments)\"}';
		}
        Instance.API.fql.multiquery(function(pXMLHttpRequest){
            CommentsOnComplete(pXMLHttpRequest);
        }, Instance.API.createAPIParams({
            queries: strMultiQuery,
            format: "JSON"
        }));
	}
    /*End Interactive Device*/
   
    function CommentsOnComplete(pXMLHttpRequest){
		
        if (!Instance.Main.checkNetworkError(pXMLHttpRequest)) return;
		
        FBTrace(pXMLHttpRequest.responseText);
        var objResponse = Util.DecodeJSON(pXMLHttpRequest.responseText);
		
        var objComment = null;
		var objProfile = null;
		
		if (objResponse[0].name == "comments") {
			objComment = objResponse[0].fql_result_set;
			if(Util.isEmptyObject(objComment)) {
				Instance.Loading.close();
				iRemoteFB.hideLoading();
				completeFn(false);
				return;
			}
			objComment = Util.reverseArray(objComment);
		}

		if (objResponse[1].name == "profile")	{
			objProfile = objResponse[1].fql_result_set;
		}
		
		var refProfile = {};
		var objProfileLength = objProfile.length;
		for (var profileIdx = 0; profileIdx < objProfileLength; profileIdx++) {
            refProfile[objProfile[profileIdx].uid] = {
                name: objProfile[profileIdx].name,
                pic_square: objProfile[profileIdx].pic_square
            };
		}

		var objCommentLength = objComment.length;
		var tID = "";
		for (var streamIdx = 0; streamIdx < objCommentLength; streamIdx++) {
			tID = objComment[streamIdx].fromid;
			if (refProfile[tID]) {
				objComment[streamIdx].pic_square = refProfile[tID].pic_square ? refProfile[tID].pic_square : "http://static.ak.fbcdn.net/pics/q_silhouette.gif";
				objComment[streamIdx].name = refProfile[tID].name;
			} else {
				objComment[streamIdx].pic_square = "http://static.ak.fbcdn.net/pics/q_silhouette.gif";
				objComment[streamIdx].name = "Unknown";
			}
		}
		Instance.Loading.close();	
		iRemoteFB.hideLoading();
        completeFn(objComment);
    }

    this.del = function(pCommentID, pCompleteFn){
		Instance.Loading.open();
		iRemoteFB.showLoading("Loading Data");
        completeFn = pCompleteFn;
        
        Instance.API.stream.removeComment(function(pXMLHttpRequest){
            DeleteOnComplete(pXMLHttpRequest);
        }, Instance.API.createAPIParams({
            comment_id: pCommentID,
            format: "JSON"
        }));
        
    }
    
    function DeleteOnComplete(pXMLHttpRequest){

        if (!Instance.Main.checkNetworkError(pXMLHttpRequest)) return;
		
        FBTrace(pXMLHttpRequest.responseText);
        var objResponse = Util.DecodeJSON(pXMLHttpRequest.responseText);
		
		Instance.Loading.close();
		iRemoteFB.hideLoading();
		
		if (objResponse === true) {
	        completeFn(Facebook.Define.Success);
		} else if (objResponse.error_code) {
			FBTrace_("error_code : "+objResponse.error_code);
			FBTrace_("error_msg : "+objResponse.error_msg);
			completeFn(Facebook.Define.Fail);
		}
    }

}
