function CommentsListView(pObjDiv){
	var objDiv = pObjDiv;
	
	objDiv = pObjDiv;
	objDiv.style.position = "absolute";
	objDiv.style.left = "0px";
	objDiv.style.top = "0px";
	objDiv.style.width = "960px";
	objDiv.style.height = "540px";
	objDiv.style.visibility = "hidden";''
	
	var iPage = null;
	var objLastComments = "";
	
	var strHelpNaviDiv = "_CommentsListView_HelpNavi_";
	var objHelpNaviDiv = null;
	
	this.update = function(pComments, pPage){
		FBTrace("CommentsListView -> update");
		iPage = pPage;
		WIDGET.putInnerHTML(objDiv,generateHTML(pComments));
	}
	
	this.show = function(){
		FBTrace("CommentsListView -> show");
		objDiv.style.visibility = "visible";
	}
	
	this.hide = function(){
		FBTrace("CommentsListView -> hide");
		objDiv.style.visibility = "hidden";''
	}
	
	this.clear = function() {
		WIDGET.putInnerHTML(objDiv,"");
	}
	
	this.focus = function(pIdx){
		_document.getElementById(getFocusID(pIdx)).style.backgroundImage= "url(Resource/images/popup_focus.png)";
	}
	
	this.blur = function(pIdx){
		_document.getElementById(getFocusID(pIdx)).style.backgroundImage= "url()";
	}

	this.needFull = function(pIdx) {
		var contentsScrollHeight = _document.getElementById("_CommentsListView_NeedFull_" + pIdx).scrollHeight;
		if (contentsScrollHeight > 54) {
			return true;
		} else {
			return false;
		}
	}

	var Style = {
		background: { left: "154px", top: "36px", width: "651px",	height: "434px", 'background-image': "url(Resource/images/popup_bg.png)" 	},
		title: { left: "189px", top: "59px", width: "600px", color: "#f1eeee", font: "16px bold", 'text-align': "left" 	},
		page: { right: "190px", top: "59px", width: "600px", color: "#f1eeee", font: "16px bold", 'text-align': "right" 	},
		focus : { left: "-9px", top: "-9px", width: "565px", height : "103px" },
		userPic : {	left: "1px", top: "1px", color : "#252b34", font : "16px bold"	},
		name: { left: "82px", top: "4px", height : "60px", color : "#252b34", font : "16px bold"	},
		contents : { left: "0px", top: "0px", 	height : "54px",	width: "465px",	color : "#252b34",	font : "16px",'line-height' : "18px",
			overflow : "hidden",
			'z-index' : 1
		},		
		contentsWrapper : { left: "82px", top: "31px", width: "465px",	height : "54px",	'overflow': 'hidden'	},
		textLine : { left: "0px", top: "93px", width: "550px", height : "2px"	}
	}
	
	var arrCommentsPosition = [{
		left: "197px", top: "108px", width : "532px", height : "103px"
	}, {
		left: "197px", top: "211px" , width : "532px", height : "103px"
	}, {
		left: "197px", top: "314px" , width : "532px", height : "103px"
	}];
	
	function generateHTML(pComments){
		objLastComments = pComments;
		var strHTML = "<div style = 'background:url(Resource/images/popup_blackbg.png);position:absolute;width:960px;height:540px;left:0px;top:0px'>";
		strHTML += "<div style = '" + Util.getStyle(Style.background) + "'></div>";
		strHTML += "<div style = '" + Util.getStyle(Style.title) + "'>"+SID_COMMENTS_LIST+"</div>";
		
		// Help Area
		strHTML += "";
		
		var commentslength = pComments.length;
		for (commentIdx = 0; commentIdx < commentslength; commentIdx++) {
			strHTML += "<div style = '"+Util.getStyle(arrCommentsPosition[commentIdx])+"'>";
			strHTML += "<img src = '"+pComments[commentIdx].pic_square+"' style = '"+Util.getStyle(Style.userPic)+"'>";
			strHTML += "<div style = '"+Util.getStyle(Style.name)+"'>"+pComments[commentIdx].name + " ["+Util.getTime(pComments[commentIdx].time)+"]</div>";
			
			strHTML += "<div style = '"+Util.getStyle(Style.contentsWrapper)+"'>";
			strHTML += "<div id = '_CommentsListView_NeedFull_"+commentIdx+"' style = '"+Util.getStyle(Style.contents)+"'>"+Util.seperateString(pComments[commentIdx].text)+"</div>";
			strHTML += "</div>";
			strHTML += "<div id = '"+getFocusID(commentIdx)+"' style = '"+Util.getStyle(Style.focus)+"'></div>"
			strHTML += (commentIdx < (commentslength - 1)) ? "<img src ='Resource/images/popup_textline.png' style = '"+Util.getStyle(Style.textLine)+"'>" : "";
			strHTML += "</div>";
		}
		strHTML += "<div id = '"+strHelpNaviDiv+"' style = 'position:absolute;left:0px;top:0px;width:960px;height:540px;overflow:hidden'>";
		strHTML += Util.getHelpNavi(175,422,600,35,[
			{	image : HelpArea.Image.Green,		text : SID_COMMENTS		},
			{	image : HelpArea.Image.Blue,		text : FBID_PROFILE			},
			{	image : HelpArea.Image.GEnter,	text : SID_MORE_VIEW		},
			{	image : HelpArea.Image.GReturn,	text : SID_RETURN			}
		]);
		strHTML += "</div>";
		
		var nTotalPages = iPage.getTotalPages();
		var nCurrentPages = iPage.getCurPage();
		if (nTotalPages > 1) {
			
			strHTML += Util.getScrollBar({	
				currentPage : nCurrentPages, totalPage : nTotalPages,
				left : 758, top : 121, width : 3, height : 266,
				backgroundSrc : "Resource/images/scroll_bg_04.png",
				barSrc : "Resource/images/scroll_02.png"
			});
			
			var arrowUpStyle = { left : "753px", top : "108px", width : "13px", height : "7px" }
			var arrowDownStyle = { left : "753px", top : "393px", width : "13px", height : "7px" }
			
			strHTML += Util.addImage(Util.getStyle(arrowUpStyle),"Resource/images/arrow_up02.png");
			strHTML += Util.addImage(Util.getStyle(arrowDownStyle),"Resource/images/arrow_down02.png");
		}
		strHTML += "<div style = '" + Util.getStyle(Style.page) + "'>"+(nCurrentPages+1)+"/"+nTotalPages+"</div>";
		strHTML += "</div>";
		FBTrace(strHTML);
		return strHTML;
	}
	
	this.refresh = function() {
		FBTrace("CommentsListView -> refresh");
		WIDGET.putInnerHTML(objDiv,generateHTML(objLastComments));
	}
	
	function getFocusID(pIdx){
		return "_CommentsListView_" + pIdx;
	}
}
