function AudioPlugin() {
	var objPlugin = _$("pluginAudio");
	var objVersion = objPlugin.GetPluginInfo(PL_CMN_INFO_VERSION);	
	
	this.volumeUp = function() {
        var outputDevice = objPlugin.GetOutputDevice();
        if (outputDevice == PL_AUDIO_OUTPUT_DEVICE_EXTERNAL) {
            alert("External Speaker Connected.!!!!")
            return false;
        }
        objPlugin.SetVolumeWithKey(PL_AUDIO_VOLUME_KEY_UP);
        
        if (outputDevice == PL_AUDIO_OUTPUT_DEVICE_RECEIVER) {
            alert("Receiver Connected!! ");
            return false; // 리시버 연결시 아무것도 안함.
        }
        
        return true;
	}
	
	this.volumeDown = function() {
		var outputDevice = objPlugin.GetOutputDevice();
        if (outputDevice == PL_AUDIO_OUTPUT_DEVICE_EXTERNAL) {
            alert("External Speaker Connected.!!!!")
            return false;
        }
        objPlugin.SetVolumeWithKey(PL_AUDIO_VOLUME_KEY_DOWN);	
        
        if (outputDevice == PL_AUDIO_OUTPUT_DEVICE_RECEIVER) {
            alert("Receiver Connected!! ");
            return false; // 리시버 연결시 아무것도 안함.
        }
        return true;
	}
	
	this.mute = function() {
	  	var outputDevice = objPlugin.GetOutputDevice();
		if( outputDevice == PL_AUDIO_OUTPUT_DEVICE_EXTERNAL){
			alert("External Speaker Connected.!!!!");
			
			return false;
		}
	
		var tMuteState = this.getMute();	
		if(tMuteState){
			if (objVersion > "AUDIO-0004") {
				objPlugin.SetUserMute(PLR_FALSE);		//Mute 해제
			}else{
				objPlugin.SetMute(PL_AUDIO_MUTE_OFF);		//Mute 해제
			}
			alert("Mute Off. speaker on.");
		}else{
			if (objVersion > "AUDIO-0004") {
				objPlugin.SetUserMute(PLR_TRUE);		//Mute 설정.
			}else{
				objPlugin.SetMute(PL_AUDIO_MUTE_ON);		//Mute 설정.
			}
			alert("Mute On. speaker off.");
		}
		if( outputDevice == PL_AUDIO_OUTPUT_DEVICE_RECEIVER ) {			
			alert( "Receiver Connected!! " );
			return false;// 리시버 연결시 아무것도 안함.
		}	
		return true;
	}
	
	this.setSystemMute = function(pOption) {
		objPlugin.SetSystemMute(pOption);
	}
	
	this.getVolume = function() {
		return objPlugin.GetVolume();
	}
	
	this.getMute = function() {
	  	var tRtn = 0;
		if( objVersion  > "AUDIO-0004"){
			tRtn = objPlugin.GetUserMute();
		}else{
			tRtn = objPlugin.GetMute();
		}
		return tRtn;
	}
}
