function Loading(pViewInstance) {
	var iView = pViewInstance;
	var bLoading = false;
	var bPreventKey = false;
	
	iView.init();
	
	this.open = function(pPreventKey) {
        if (pPreventKey) {
            Instance.Main.preventKeyEvent();
            bPreventKey = true;
        }
		iView.show();
	}
	
	this.close = function() {
		if (bPreventKey) {
			Instance.Main.releaseKeyEvent();
			bPreventKey = false;
		}
		iView.hide();		
	}
	
	this.isLoading = function() {
		return bLoading;
	}
}

var gObjLoading = null;
var gLoadingIdx = 0;
var gLoadingTimer = null;

var gArrLoadingImage = [
	"Resource/images/loading/sbs_video_loading_01.png",
	"Resource/images/loading/sbs_video_loading_02.png",
	"Resource/images/loading/sbs_video_loading_03.png",
	"Resource/images/loading/sbs_video_loading_04.png",
	"Resource/images/loading/sbs_video_loading_05.png",
	"Resource/images/loading/sbs_video_loading_06.png",
	"Resource/images/loading/sbs_video_loading_07.png",
	"Resource/images/loading/sbs_video_loading_08.png",
	"Resource/images/loading/sbs_video_loading_09.png",
	"Resource/images/loading/sbs_video_loading_10.png",
	"Resource/images/loading/sbs_video_loading_11.png",
	"Resource/images/loading/sbs_video_loading_12.png"
];

function LoadingView(pObjDiv) {
	var objDiv = pObjDiv;
	objDiv = pObjDiv;
	objDiv.style.position = "absolute";
	objDiv.style.left = "0px";
	objDiv.style.top = "0px";
	objDiv.style.width = "960px";
	objDiv.style.height = "540px";
//	objDiv.style.display = "none";
	objDiv.style.visibility = "hidden";
	objDiv.style.zIndex = 1;
	
	var objLoading = null;
	var nLoadingIdx = 0;
	var loadingTimer = null;
	
	Style = {
		Base :
			{	left:"397px",top:"215px",width:"166px",height:"140px"	},
		Loading : 
			{	left:"444px",top:"250px",width:"72px",height:"72px"	},
		Caption :
			{	left:"440px",top:"308px",width:"80px",height:"72px", 'text-align':"center",color:"#FFFFFF", font:"16px"	}
	}
	
	this.init = function() {
		var strHTML = "";
		var tempHTML = "";
		tempHTML += "<table cellspacing='0' cellpadding='0'>";
		tempHTML += "<tr>";
		tempHTML += "<td class='loading_bg_top_1'></td>";
		tempHTML += "<td class='loading_bg_top_2'></td>";
		tempHTML += "<td class='loading_bg_top_3'></td>";
		tempHTML += "</tr>";
		tempHTML += "<tr>";
		tempHTML += "<td class='loading_bg_mid_1'></td>";
		tempHTML += "<td class='loading_bg_mid_2'></td>";
		tempHTML += "<td class='loading_bg_mid_3'></td>";
		tempHTML += "</tr>";
		tempHTML += "<tr>";
		tempHTML += "<td class='loading_bg_bottom_1'></td>";
		tempHTML += "<td class='loading_bg_bottom_2'></td>";
		tempHTML += "<td class='loading_bg_bottom_3'></td>";
		tempHTML += "</tr>";
		tempHTML += "</table>";
		strHTML += Util.addDiv(Util.getStyle(Style.Base),tempHTML);
		strHTML += Util.addImage(Util.getStyle(Style.Loading),gArrLoadingImage[0],"_facebookLoadingImage_");
//		strHTML += Util.addDiv(Util.getStyle(Style.Caption),FACEBOOK_LOADING);
		WIDGET.putInnerHTML(objDiv,strHTML);
		gObjLoading = _$("_facebookLoadingImage_");
	}
	
	this.show = function() {
		bLoading = true;
//		objDiv.style.display = "block";
		objDiv.style.visibility = "visible";
		activate();
	}

	this.hide= function() {
		bLoading = false;
//		objDiv.style.display = "none";	
		objDiv.style.visibility = "hidden";		
		deactivate();
	}
	
	function activate() {
		if (!gLoadingTimer) {
			gLoadingTimer = setInterval("ChangeLoadingImage()", 500);
		}
	}
	
	function deactivate() {
		clearInterval(gLoadingTimer);
		gLoadingTimer = null;
	}
}

function ChangeLoadingImage() {
	if (gLoadingIdx < (gArrLoadingImage.length - 1)) {
		gLoadingIdx++;
	}
	else {
		gLoadingIdx = 0;
	}
	gObjLoading.src = gArrLoadingImage[gLoadingIdx];
}

function innerLoading(pOption) {
	var nCurLoadingImg = 1;
	var divContainer = pOption.container;
	var strLoadingDIVName = "_innerLoading_" + pOption.id;  
	
	var divLoading = null;
	var timerLoading = null;

	var styleLoading = {
		left : pOption.left + "px", top : pOption.top + "px", width : "72px", height : "72px"
	}

	this.open = function() {
		FBTrace_("innerLoading.open");
		divContainer.style.visibility = "visible";
		var strHTML = Util.addImage(Util.getStyle(styleLoading),"Resource/images/loading/sbs_video_loading_01.png",strLoadingDIVName);
		WIDGET.putInnerHTML(divContainer,strHTML);
		timerLoading = setTimeout(function(){
			divLoading = _document.getElementById(strLoadingDIVName);
			changeLoadingImg();
		},200);
	}
	
	this.close = function() {
		FBTrace_("innerLoading.close");
		divContainer.style.visibility = "hidden";
		clearTimeout(timerLoading);
	}
	
	function changeLoadingImg() {
		FBTrace_("innerLoading.changeLoadingImg " + pOption.id + " " + divLoading.id + " " + nCurLoadingImg);
		nCurLoadingImg++;
		nCurLoadingImg = nCurLoadingImg > 12 ? 1 : nCurLoadingImg;
		divLoading.src = "Resource/images/loading/sbs_video_loading_"+(nCurLoadingImg > 9 ? nCurLoadingImg : "0"+nCurLoadingImg)+".png";
		timerLoading = setTimeout(function(){
			changeLoadingImg();
		},200);
	}
}
