function MultilineInput() {
	var MultilineInputObject = {
		ID : "facebookIME",
		Background : {
			style : {
				width : '461px',	height : '289px', left : '112px', top : '105px',
				'background-image' : 'url(Resource/images/comment_popup_bg.png)'
			}
		},
		Title : {
			text : "",
			style : {
				width : '461px', height : '30px',	left : '112px', top : '128px',
				'color' : '#F1EEEE', 'font-size' : '16px', 'text-align' : 'center', 'font-weight' : 'bold'
			}
		},
		View : {
			style: {
				width: '365px',	height: '103px', left: '157px',	top: '178px',
				'font-size': '16px', 'color': '#434343'
			//		'border' : '1px solid #00FF00'
			}
		},
		Scroll : {
			image : 'Resource/images/scroll_02.png',
			style  : {
				left : '529px'
			}
		},
		ScrollBG : {
			image : 'Resource/images/popup_scroll_bg.png',
			style  : {
				left : '529px'
			}
		},
		Input : {
			text : "",
			style : {
				width : '391px',	height : '34px',	left : '147px', top : '302px',
				'size' : '35', 'font-size' : '16px',	'color' : '#434343', 'maxlength' : 210
			}
		},
		IME : {
			left : '573px', top : '106px'
		},
		HelpArea : {
			left : '145px', top : '355px', width : '395px', height : '30px',
	//		'border' : '1px solid #00FF00',
			'text-align' : 'right'
		},
		HelpItems : [
			{
				button : {
					image : 'Resource/images/viewmode_addicon.png',
					style : {
						width : '24px', height : '16px'
					}
				},
				label : {
					text : SID_OK, 
					style : { 
						'font-size' : '16px', 'font-weight' : 'bold', 'color' : '#434343'
					}
				}
			},
			{
				button : {
					image : 'Resource/images/help_icon_y.png',
					style : {
						width : '28px', height : '28px'
					}
				},
				label : {
					text : SID_SPACE_WORD, 
					style : { 
						'font-size' : '16px', 'font-weight' : 'bold', 'color' : '#434343'
					}
				}
			},
			{
				'button' : {
					image : 'Resource/images/viewmode_backicon.png',
					style : {
						width : '24px', height : '16px'
					}
				},
				label : {
					text : SID_RETURN, 
					style : { 
						'font-size' : '16px', 'font-weight' : 'bold', 'color' : '#434343'
					}
				}
			}
		]
	}
	
	var _this_ = this;
	var returnFn = null;

	var strConsoleDivTitle = MultilineInputObject.ID+"_Title_";
	var strConsoleDivBack = MultilineInputObject.ID+"_Background_";
	var strConsoleDivView = MultilineInputObject.ID+"_View_";
	var strConsoleDivContents = MultilineInputObject.ID+"_Contents_";
	var strConsoleDivHelp = MultilineInputObject.ID+"_Help_";
	var strInputDiv = MultilineInputObject.ID+"_Input_";
	var strScrollImage = MultilineInputObject.ID+"_Scroll_";
	var strScrollImageBG = MultilineInputObject.ID+"_ScrollBG_";

	var strLastContents = "";
	
	var objDiv = document.getElementById(MultilineInputObject.ID);
	
	objDiv.style.visibility = "hidden";
	objDiv.style.zIndex = 1;
	
	if (!objDiv) {
//		alert("MultilineInput -> Invalid <div> name");
	}

	// Initializing text input div
	initDiv();

	var objConsoleDivTitle = document.getElementById(strConsoleDivTitle);
	var objConsoleDivView = document.getElementById(strConsoleDivView);
	var objConsoleDivContents = document.getElementById(strConsoleDivContents);
	var objInputDiv = document.getElementById(strInputDiv);
	var objScrollImage = document.getElementById(strScrollImage);
	var objScrollImageBG = document.getElementById(strScrollImageBG);
	
	var nConsoleDivHeight = parseInt(MultilineInputObject.View.style.height,10);
	var nConsoleScrollHeight = 0;
	var nConsoleScrollWidth = objConsoleDivContents.scrollWidth;
	
	var instanceIME = null;

	setTimeout(function(){
		instanceIME = new IMEShell(strInputDiv, MultilineInputInit);
	},200);

	this.open = function(pTitle, pMsg, pReturnFn) {
		Instance.Main.setKeyHandler(function(){}, "IMEMode");
		returnFn = pReturnFn;
		setTitle(pTitle);
		
		Instance.Main.popupHelpNavi();

		_this_.showIME(pMsg);
		
		// auto hide timer
		setTimer(true);
	}
	
	this.close = function() {
		Instance.Main.restoreKeyHandler();
		objDiv.style.visibility = "hidden";
		Instance.Main.focus();
		
		// auto hide timer
		setTimer(false);
	}

	this.showIME = function(pMsg) {
		objDiv.style.visibility = "visible";
		var imeobj = instanceIME.getInputObj();
		if (typeof(pMsg) == "string" && pMsg) {
			instanceIME.setString(pMsg);
			update(imeobj.value);
		} else if (MultilineInputObject.Contents) {
			instanceIME.setString(MultilineInputObject.Contents);
			update(imeobj.value);
		}
		imeobj.focus();
	}

	function MultilineInputInit(imeobj) {
		var inputobj = imeobj.getInputObj();		
		alert("start initializing : "+inputobj.id);
		imeobj.setKeypadPos(parseInt(MultilineInputObject.IME.left,10),parseInt(MultilineInputObject.IME.top,10),20);
		imeobj.setKeyFunc(TV.KEY_RETURN,function(){
			_this_.close();
			// [DMS00733308] 
			// close() ??inputobj 초기?�할 ??
			// setString()?� inputobj???�커?��? 주는 부?�용???�어 ?�용?��? ?�음.
			inputobj.value = '';
//			imeobj.setString("");
			returnFn(false);
		});
		imeobj.setKeyFunc(TV.KEY_EXIT,function(){
			_this_.close();
			inputobj.value = '';
			returnFn(false);
		});
		imeobj.setKeyFunc(TV.KEY_ENTER,function(){
			var retValue = inputobj.value;
			_this_.close();
			inputobj.value = '';
			returnFn(retValue.replace("&","%26").replace("+","%2B"));
		});
		
		imeobj.setAnyKeyFunc(function(keyValue){
			keyEventListner(keyValue);
			// auto hide timer
			if (objDiv.style.visibility == "visible") {
				setTimer(true);
			}
		});
		
		imeobj.setMaxLengthFunc(function(keyValue){
			_this_.close();
			Instance.Popup.enter({
                title: FACEBOOK_NAME,
                message: SID_MIX_MESSAGES_MOT_EXCEED_A_CHARACTERS.Replace("210"),
                buttons: [{ caption: SID_OK, value: true}]
            }, function(){
				_this_.showIME();
			});
			return;
		});
	}
	
	function keyEventListner(pKeyCode, pObject) {
		var imeobj = instanceIME.getInputObj();
		update(imeobj.value);
	}
	
	function adjustScroll() {
		var imeobj = instanceIME.getInputObj();
		var nCurPosition = imeobj.cursorPosition;
		var nFullLength = imeobj.value.length;
		var nScrollPosition = Math.floor((nConsoleScrollHeight-nConsoleDivHeight) * (nCurPosition/nFullLength));
		nScrollPosition = nScrollPosition > 0 ? nScrollPosition : 0;
		
		objConsoleDivContents.style.top = "-" + nScrollPosition + "px";	

		if (nConsoleScrollHeight - nConsoleDivHeight > 0) {
			var nScrollImageHeight = Math.floor(parseInt(MultilineInputObject.View.style.height,10) * (nConsoleDivHeight / nConsoleScrollHeight));
			var nScrollImageTop = parseInt(MultilineInputObject.View.style.top,10) + Math.floor((parseInt(MultilineInputObject.View.style.height,10) - nScrollImageHeight) * (nCurPosition / nFullLength));

			alert("nScrollImageHeight : " + nScrollImageHeight);
			alert("nScrollImageTop : " + nScrollImageTop);
			
			objScrollImage.style.height = nScrollImageHeight + "px";
			objScrollImage.style.top = nScrollImageTop + "px";
			objScrollImage.style.visibility = "visible";
			objScrollImageBG.style.visibility = "visible";
		} else {
			objScrollImage.style.visibility = "hidden";
			objScrollImageBG.style.visibility = "hidden";
		}
	}
	
	function update(strText) {
		if (strLastContents != strText) {
			WIDGET.putInnerHTML(objConsoleDivContents,Util.seperateString(strText));
		} else {
			alert("Contents doesn't changed.");
		}
		strLastContents = strText;
		setTimeout(function(){
			nConsoleScrollHeight = objConsoleDivContents.scrollHeight;
			adjustScroll();
		},0);
	}
	
	function initDiv() {
		var strHTML = "";

		strHTML += Util.addDiv(Util.getStyle({left:"0px",top:"0px",width:"960px",height:"540px",'background':"url(Resource/images/popup_blackbg.png)"}),"");
		strHTML += "<div id = '"+strConsoleDivBack+"' style = 'position:absolute;overflow:hidden;"+getStyle(MultilineInputObject.Background.style)+"'></div>";
		strHTML += "<div style = 'position:absolute;left:0px;top:0px;width:960px;height:540px'>";
			strHTML += "<div id = '"+strConsoleDivTitle+"' style = 'position:absolute;overflow:hidden;"+getStyle(MultilineInputObject.Title.style)+"'>"+MultilineInputObject.Title.text+"</div>";
			strHTML += "<div id = '"+strConsoleDivView+"' style = 'position:absolute;overflow:hidden;"+getStyle(MultilineInputObject.View.style)+"'>";
				strHTML += "<div id = '"+strConsoleDivContents+"' style = 'position:absolute;width:"+(parseInt(MultilineInputObject.View.style.width,10)-10)+"px'></div>";
			strHTML +=  "</div>";
			strHTML += "<div style = 'position:absolute;left:0px;top:0px;width:960px;height:540px'>";
				strHTML += "<input size = "+MultilineInputObject.Input.style.size+" type = 'text' id = '"+strInputDiv+"' maxlength = "+MultilineInputObject.Input.style.maxlength+" style = 'position:absolute;border:0px;"+getStyle(MultilineInputObject.Input.style)+"'>";
				strHTML += "<div id = '"+strConsoleDivHelp+"' style = 'position:absolute;border:0px;"+getStyle(MultilineInputObject.HelpArea)+"'>" + makeHelpArea(MultilineInputObject.HelpArea, MultilineInputObject.HelpItems) + "</div>";
				strHTML += "<img id = '"+strScrollImageBG+"' src = '"+MultilineInputObject.ScrollBG.image+"' style = 'position:absolute;visibility:hidden;top:"+parseInt(MultilineInputObject.View.style.top,10)+"px;width:3px;height:103px;"+getStyle(MultilineInputObject.ScrollBG.style)+"'>";				
				strHTML += "<img id = '"+strScrollImage+"' src = '"+MultilineInputObject.Scroll.image+"' style = 'position:absolute;visibility:hidden;top:0px;width:3px;"+getStyle(MultilineInputObject.Scroll.style)+"'>";				
			strHTML += "</div>";
		strHTML += "</div>";		

		alert(strHTML);
		WIDGET.putInnerHTML(objDiv,strHTML);
	}
	
	function setTitle(pTitle) {
		_$(strConsoleDivTitle).innerHTML = pTitle;
	}
	
	function makeHelpArea(pHelpArea, pHelpItems) {
		var arrLength = pHelpItems.length;
		var strHTML = "<table><tr>";
		for (var helpIdx = 0; helpIdx < arrLength; helpIdx++) {
			strHTML += "<td style = 'width:5px;'></td>";
			strHTML += "<td style = 'vertical-align:middle;height:"+pHelpArea.height+";"+"'><img src = '"+pHelpItems[helpIdx].button.image+"'></td>";
			strHTML += "<td style = '"+getStyle(pHelpItems[helpIdx].label.style)+"'>"+pHelpItems[helpIdx].label.text+"</td>";
		}
		strHTML+= "</tr></table>";
		alert(strHTML);
		return strHTML;
	}
	
    function getStyle(pObjectStyle){
        var strDivHTML = "";
        for (var name in pObjectStyle) {
            strDivHTML += name + ":" + pObjectStyle[name] + ";"
        }
        return strDivHTML;
    }
	
	// auto hide timer
	var timer = null;
	var HIDE_TIME = 120000;		// 120 sec
//	var HIDE_TIME = 3000;		// for test
	function setTimer (bOn) {
		if (timer != null) {
			clearTimeout(timer);
			timer = null;
		}
		if (bOn) {
			timer = setTimeout(function(){
				
				// IME deinitialize (to close "IME Language Popup")
				_g_ime.deinit();
				
				_this_.close();
				// 강제�??�는 경우?�는 T9 버퍼가 초기?��? ?�됨 -> setString??불러????
//				(instanceIME.getInputObj()).value = '';
				instanceIME.setString("");
				update('');
				returnFn(false);
			}, HIDE_TIME);
		}
	}
}