function Page(pItemLength, pItemPerPage) {
	var nTotalPages = Math.ceil(pItemLength/pItemPerPage);
	var nCurPage = 0;		// 0 Based
	
	var nTotalItems = pItemLength;
	var nCurItem = 0;		// 0 Based
	
	this.getTotalItems = function() {
		return nTotalItems;
	}
	
	this.getCurPage = function() {
		return nCurPage;
	}
	 
	this.getTotalPages = function() {
		return nTotalPages;
	}
	
	this.getCurItemIdx = function() {
		return nCurItem;
	}

	this.setCurPage = function(pPage) {
		nCurPage = pPage;
	}

	this.setCurItemIdx = function(pItemIdx) {
		var isPageChanged = false;
		nCurItem = pItemIdx;
		var tempPage = Math.floor(pItemIdx/pItemPerPage);
		if (nCurPage != tempPage) {
			isPageChanged = true;
			nCurPage = tempPage;
		}
		return isPageChanged;
	}

	this.getIdxInPage = function() {
		return nCurItem % pItemPerPage;
	}
	
	this.getStartIdx = function() {
		return pItemPerPage * nCurPage;
	}
	
	this.getLastIdx = function() {
		var lastIdx = pItemPerPage * (nCurPage + 1) - 1;
		lastIdx = ( lastIdx > (nTotalItems-1) ) ? (nTotalItems-1) : lastIdx;
		return lastIdx;
	}
}
