function FacebookFrame() {
	var _this_ = this;
	
    //var iMenu = null;
	var strUserID = "";
	var objUser = null;
	var frameType = null;
	var defaultFocusID = null;
	var shortCut = false;
	var strFanPageName = "";
	
	var iData = new FacebookFrameData();
     
     /*
        iStreamNews and iStreamWall
     */
     
    	iStreamNews = new Stream(new StreamView(_$("facebookStreamDiv")), new StreamNewsData(),returnMainMenu);
   	iStreamHomeStatus = new Stream(new StreamView(_$("facebookStreamDiv")), new StreamNewsData(),returnMainMenu);
    	iStreamHomePhotos = new Stream(new StreamView(_$("facebookStreamDiv")), new StreamNewsData(),returnMainMenu);
    	iStreamHomeVideos = new Stream(new StreamView(_$("facebookStreamDiv")), new StreamNewsData(),returnMainMenu);
    	iRequestList = new RequestList(new RequestListView(_$("facebookRequestListDiv")), new RequestListData(),returnMainMenu);
    	iStreamWall = new Stream(new StreamView(_$("facebookStreamDiv")), new StreamWallData(),returnMainMenu);
    	var iInfo = new Info(new InfoView(_$("facebookStreamDiv")), new InfoData(),returnMainMenu);
    	iPhotoAlbum = new PhotoAlbum(new PhotoAlbumView(_$("facebookPhotoAlbumDiv")), new PhotoAlbumData(),returnMainMenu);
    	var iStreamVideoList =  new StreamVideoList(new StreamVideoListView(_$("facebookStreamVideoListDiv")),new StreamVideoListData(), returnMainMenu);
    	IStreamVideoList = iStreamVideoList ;
    	var iFriendsList = new FriendsList(new FriendsListView(_$("facebookFriendsListDiv")),new FriendsListData(), returnMainMenu);

	var iPageInfo = new Info(new InfoView(_$("facebookStreamDiv")), new PageInfoData(),returnMainMenu);
	var iPageVideo = new VideoList(new StreamVideoListView(_$("facebookStreamVideoListDiv")),new VideoListData(), returnMainMenu);
	IStreamVideoList = iPageVideo;
	var arrFrameHistory = [Instance.Main.getLoginID()];
	
	function closeInstance() {
		iStreamNews.close();
		iRequestList.close(); 
		iStreamWall.close();
		iInfo.close();
		iPhotoAlbum.close();
		iStreamVideoList.close();
		iFriendsList.close();
		iPageInfo.close();
		iPageVideo.close();
	}
	
	this.start = function(pUserID, pDefaultFocusID, pShortCut) {
		arrFrameHistory = [];
		this.open(pUserID, pDefaultFocusID, pShortCut);
	}

    /*
     	Function: open
			Open facebook frame
			
     	Parameters: pUserID, pDefaultFocusID, pShortCut
     	Returns: N/A
     */
	this.open = function(pUserID, pDefaultFocusID, pShortCut) {
		Instance.Main.preventKeyEvent();
		closeInstance();
		
		defaultFocusID = pDefaultFocusID;
		shortCut = pShortCut;
		
		var oFrameInfo = pUserID;
		if (!oFrameInfo.type) {
			// Normal user profile
			strUserID = oFrameInfo;
		} else {
			// New type user (Fan Page)
			strUserID = oFrameInfo.id
		}
		
		FBTrace("FacebookFrame -> open : " + strUserID);
			
		_$("facebookFrameDiv").style.visibility = "visible";
		_$("facebookMenuDiv").style.visibility = "visible";
		_$("facebookContentsDiv").style.visibility = "visible";
		
		// 현재 User의 페이지 내에서 Open 되는 경우는 History에 추가하지 않음
		var oLastInfo = arrFrameHistory[arrFrameHistory.length-1];
		oLastInfo = oLastInfo ? oLastInfo : {};
		var sLastID = oLastInfo.type ? oLastInfo.id : oLastInfo;
		if (strUserID != sLastID) {
			arrFrameHistory.push(oFrameInfo);
		}
		
		if (!oFrameInfo.type) {
			iData.requestUserInfo(strUserID,OnCompleteUserInfo);
		} else {
			strFanPageName = oFrameInfo.name;
			frameType = FacebookFrame.Define.FAN_PAGE;
			makeFrameMenu();
		}
	}

	this.go = function(pFocusID, pShortCut) {
		iMenu.go(pFocusID);
		
		if (pShortCut)
			iMenu.shortCut(pShortCut);
		
		Instance.Main.setKeyHandler(keyHandler, "MainMenu");
	}

	this.getType = function() {
		return frameType;
	}

	this.getUser = function() {
		if (objUser) 
			return objUser;
		else 
			return {name:""};
	}

	this.getFrameUserID = function() {
		return strUserID;
	}

	this.updateMenu = function(pParent, pChildren) {
		iMenu.Replace(pParent, pChildren);
	}

	function getDefaultFocusID() {
		if (defaultFocusID) {
			return defaultFocusID;
		} else {
			switch(_this_.getType()) {
				case FacebookFrame.Define.ME : 
					return Facebook.Define.Menu.NEWS_FEED;
					break;
				case FacebookFrame.Define.FRIEND :
				case FacebookFrame.Define.FAN_PAGE : 
					return Facebook.Define.Menu.WALL;
					break;
				case FacebookFrame.Define.OTHER :
					return Facebook.Define.Menu.INFO;
					break;
				default :
					break;
			}
		}
	}

	function OnCompleteUserInfo(pObjUser) {
		objUser = pObjUser;
		User = objUser;
		Instance.Main.setFrameUserInfo(objUser);
		
		if (strUserID == Instance.Main.getLoginID()) {
			Instance.Main.sessionName(objUser.name);
			frameType = FacebookFrame.Define.ME;
			Instance.Main.setLoginUserInfo(objUser);
             /* Start Interactive Device */
			iRemoteFB.onLoadFacebook();
            iRemoteFB.showwallFlag = 0;
             /* End Interactive Device */
		}
		else if (objUser.isFriend) {
			frameType = FacebookFrame.Define.FRIEND;
             /* Start Interactive Device */            
            var makeMenuData = new Array();	
            makeMenuData[0] = {
                identifier : "menuID34",
                type : "custom",
                title : objUser.name,
                name : FBID_WALL,
                icon : "example/a.png",
                onClick : "action?selectthis=userWall"
            }
            makeMenuData[1] = {
                identifier : "menuID33",
                type : "custom",
                title : objUser.name,
                name : SID_INFO_CASE,
                icon : "example/a.png",
                onClick : "action?selectthis=userInfo"
            }
            makeMenuData[2] = {
                identifier : "menuID32",
                type : "custom",
                title : objUser.name,
                name : FBID_PHOTOS,
                icon : "example/a.png",
                onClick : "action?selectthis=userPhotosProfile"
            }
            makeMenuData[3] = {
                identifier : "menuID31",
                type : "custom",
                title : objUser.name,
                name : SID_VIDEOS,
                icon : "example/a.png",
                onClick : "action?selectthis=userVideosProfile"
            }
            iRemoteFB.showwallFlag = 1;
			if (checkBrowserVersion()) {
				//jQuery.sfIRemote('menu', makeMenuData);
			}             			
		} else {
			frameType = FacebookFrame.Define.OTHER;             
            var makeMenuData = "";
            makeMenuData = {
                            identifier : "menuID33",
                            type : "custom",
                            title : objUser.name,
                            name : SID_INFO_CASE,
                            icon : "example/a.png",
                            onClick : "action?selectthis=userInfo"
            }
			if (checkBrowserVersion()) {
				jQuery.sfIRemote('menu', makeMenuData);
			} 
   			iRemoteFB.showwallFlag = 1;
		}
		 /* End Interactive Device */
		// Frame Type이 Me, Friend인 경우 Wall 이 Default Focus
		// Frame Type이 Other인 경우는 Default Focus 무시
		defaultFocusID = defaultFocusID ? (_this_.getType() != FacebookFrame.Define.OTHER ? defaultFocusID : null ) : null;
		Util.printUser(_this_.getType());
		FBTrace_(defaultFocusID);
		
		makeFrameMenu();
	}

    /*
     	Function: makeFrameMenu
			Make frame menu and show it. iMenu instance run current service. 
			
     	Parameters: N/A
     	Returns: N/A
     */
	function makeFrameMenu() {
		iMenu = new Menu(new FacebookMenuView(_$("facebookMenuDiv")), getMenuObj(), getDefaultFocusID(),function(){
			eventListner();
		});
		iMenu.show();
        Instance.Main.setKeyHandler(keyHandler, "MainMenu");
		Instance.Main.releaseKeyEvent();
		
		if (shortCut)
			iMenu.shortCut(shortCut);
	}

	this.getUserInfo = function(pUserID, pCallback) {
		iData.requestUserInfo(pUserID,function(pObjUser){
			getUserInfoCallback(pObjUser, pCallback);
		});
	}
	
	function getUserInfoCallback(pObjUser, pCallback) {
		Instance.Main.sessionName(pObjUser.name);
		Instance.Main.setLoginUserInfo(pObjUser);
		pCallback();
	}
	
	this.hideMenu = function() {
		iMenu.hide();
	}
	
	this.showMenu = function() {
		iMenu.show();
	}
	
    function keyHandler(pKeyCode){
		switch (pKeyCode) {
			// Up
			case 38:
			case TV.KEY_UP:
			case TV.KEY_PANEL_CH_UP:
			case TV.KEY_WHEELUP:
				iMenu.up();
				break;
			// Down
			case 40:
			case TV.KEY_DOWN:
			case TV.KEY_PANEL_CH_DOWN:
			case TV.KEY_WHEELDOWN:
				iMenu.down();
				break;
			// Enter
			case 13:
			case TV.KEY_ENTER:
			case TV.KEY_PANEL_ENTER:
			case TV.KEY_ENTER:
				iMenu.enter();
				break;
			case TV.KEY_RIGHT:
			case TV.KEY_PANEL_VOL_DOWN:
				iMenu.right();
				break;			
			case TV.KEY_RETURN:
			// TEMS2 Code : 20100409-0035
			// Left key must react same as return key.
			case TV.KEY_LEFT:
			case TV.KEY_PANEL_VOL_UP:				
				if (iMenu.back()) {
					iMenu.close();
					arrFrameHistory.pop();
					//FBTrace("Frame History : " + arrFrameHistory);
					
					if (arrFrameHistory.length > 0) {
						Instance.Frame.open(arrFrameHistory.pop());
					}
					else {
						WIDGET.sendReturnEvent();
					}
				}
				break;
			default:
				break;
		}
	}
	
	function returnMainMenu() {
        Instance.Main.setKeyHandler(keyHandler, "MainMenu");
		iMenu.focus();
	}
	
	function getMenuObj() {
		switch (_this_.getType()) {
			case FacebookFrame.Define.ME : 
				return {
			        items: [{
			            id: Facebook.Define.Menu.HOME
						, caption: FBID_HOME_CL
		                , instance: iStreamNews
						, params : strUserID
			            , items: [
						{
			                id: Facebook.Define.Menu.NEWS_FEED
			                , caption: FBID_NEWS_FEED
			                , instance: iStreamNews
							, params : strUserID
							, icon : "catagory_icon1.png"
			            }, {
			                id: Facebook.Define.Menu.HOME_STATUS
			                , caption: FBID_STATUS_UPDATE_CL
			                , instance: iStreamNews
							, params : strUserID
							, option : Stream.Define.Text
							, icon : "catagory_icon2.png"
			            },{
			                id: Facebook.Define.Menu.HOME_PHOTOS
			                , caption: FBID_PHOTOS
			                , instance: iStreamNews
							, params : strUserID
							, option : Stream.Define.Photo
							, icon : "catagory_icon3.png"
			            },{
			                id: Facebook.Define.Menu.HOME_VIDEOS
			                , caption: SID_VIDEOS
			                , instance: iStreamNews
							, params : strUserID
							, option : Stream.Define.Video
							, icon : "catagory_icon4.png"
			            }, {
			                id: Facebook.Define.Menu.REQUEST
			                , caption: SID_FRIEND_REQUESTS
			                , instance: iRequestList
							, params : strUserID
							, icon : "catagory_icon5.png"
			            }]
			        }, {
			            id: Facebook.Define.Menu.PROFILE
			            , caption: FBID_PROFILE
		                , instance: iStreamWall
						, params : strUserID
			            , items: [{
			                id: Facebook.Define.Menu.WALL
			                , caption: FBID_WALL
			                , instance: iStreamWall
							, params : strUserID
							, icon : "catagory_icon6.png"
			            }, {
			                id: Facebook.Define.Menu.INFO
			                , caption: SID_INFO_CASE
			                , instance: iInfo
							, params : strUserID
							, icon : "catagory_icon7.png"
			            }, {
			                id: Facebook.Define.Menu.PHOTOS
			                , caption: FBID_PHOTOS
			                , instance: iPhotoAlbum
							, params : strUserID
							, icon : "catagory_icon3.png"
			            }, {
			                id: Facebook.Define.Menu.VIDEOS
			                , caption: SID_VIDEOS
			                , instance: iPageVideo
//			                , instance: iStreamVideoList
							, params : strUserID
							, icon : "catagory_icon4.png"
			            }]
			        }, {
			            id: Facebook.Define.Menu.FRIENDS
			            , caption: SID_FRIENDS
						, instance: iFriendsList
						, params : strUserID
			            , items: [{
			                id: Facebook.Define.Menu.FRIENDS_LIST
			                , caption: SID_FRIENDS_LIST
			                , instance: iFriendsList
							, params : strUserID
							, icon : "catagory_icon8.png"
			            }]
			        }]
			    };
				break;
			case FacebookFrame.Define.FRIEND :
				return {
			        items: [{
			            id: Facebook.Define.Menu.FRIENDS,
			            caption: objUser.name,
		                instance: iStreamWall,
						params : strUserID,
			            items: [{
			                id: Facebook.Define.Menu.WALL
			                , caption: FBID_WALL
			                , instance: iStreamWall
							, params : strUserID
							, icon : "catagory_icon6.png"
			            }, {
			                id: Facebook.Define.Menu.INFO
			                , caption: SID_INFO_CASE
			                , instance: iInfo
							, params : strUserID
							, icon : "catagory_icon7.png"
			            }, {
			                id: Facebook.Define.Menu.PHOTOS
			                , caption: FBID_PHOTOS
			                , instance: iPhotoAlbum
							, params : strUserID
							, icon : "catagory_icon3.png"
			            }, {
			                id: Facebook.Define.Menu.VIDEOS
			                , caption: SID_VIDEOS
			                , instance: iPageVideo
							, params : strUserID
							, icon : "catagory_icon4.png"
			            }]
			        }]
			    }
				break;
			case FacebookFrame.Define.OTHER :
				return {
			        items: [{
			            id: Facebook.Define.Menu.FRIENDS,
			            caption: objUser.name,
		                instance: iInfo,
						params : strUserID,
			            items: [{
			                id: Facebook.Define.Menu.INFO,
			                caption: SID_INFO_CASE,
			                instance: iInfo,
							params : strUserID
							, icon : "catagory_icon7",
			            }]
			        }]
			    }
				break;
			case FacebookFrame.Define.FAN_PAGE : 	
				return {
			        items: [{
			            id: Facebook.Define.Menu.FAN_PAGE,
			            caption: strFanPageName,
		                instance: iStreamWall,
						params : strUserID,
			            items: [{
			                id: Facebook.Define.Menu.WALL
			                , caption: FBID_WALL
			                , instance: iStreamWall
							, params : strUserID
							, icon : "catagory_icon6.png"
			            }, {
			                id: Facebook.Define.Menu.INFO
			                , caption: SID_INFO_CASE
			                , instance: iPageInfo
							, params : strUserID
							, icon : "catagory_icon7.png"
			            }, {
			                id: Facebook.Define.Menu.PHOTOS
			                , caption: FBID_PHOTOS
			                , instance: iPhotoAlbum
							, params : strUserID
							, icon : "catagory_icon3.png"
			            }, {
			                id: Facebook.Define.Menu.VIDEOS
			                , caption: SID_VIDEOS
			                , instance: iPageVideo
							, params : strUserID
							, icon : "catagory_icon4.png"
			            }]
			        }]
			    }
				break;
			default:
				break;
		}
	}
}

FacebookFrame.Define = {
	ME : 0,
	FRIEND : 1,
	OTHER : 2,
	FAN_PAGE : 3
};

