function PageInfoData() {
	var userID = "";
    var completeFn = null;
	
	var arrInfo = null;
	
    this.request = function(pUserID, pCompleteFn){
		userID = pUserID;
		Instance.Loading.open();
        completeFn = pCompleteFn;

		// Object Initialize
		arrInfo = [{
			caption : "Page Information",
			items : []
		}
	];
		Instance.API.GraphAPI(pUserID, function(pXMLHttpRequest){
			OnLoadData(pXMLHttpRequest);
		});
    }
    function OnLoadData(pXMLHttpRequest){
		
        if (!Instance.Main.checkNetworkError(pXMLHttpRequest)) return;
		
        var objResponse = Util.DecodeJSON(pXMLHttpRequest.responseText);
		
		for (var key in objResponse) {
			if (key == "id" || key == "name" || key == "picture" || key == "link" || key == "fan_count" || key == "is_community_page") continue;
			arrInfo[0].items.push({
				id : key,
				caption : key.toUpperCase().replace("_"," "),
				data : striptString(objResponse[key])
			});
		}
		
		Instance.Loading.close();
        completeFn(arrInfo);
		
		function striptString(pStr) {
			var sData = pStr;
			// Delete anchor
			if (sData.replace instanceof Function) {
				sData = sData.replace(/<a href=\"\S*\">/gi, "");
				sData = sData.replace(/<a href=\"\S*\"\sclass=\"\S*\">/gi, "");
				sData = sData.replace(/<\/a>/gi, "");
				sData = sData.replace(/<\/p>/gi, "");
				sData = sData.replace(/<p>/gi, "");
				sData = sData.replace(/<\/i>/gi, "");
				sData = sData.replace(/<i>/gi, "");
			}
			return sData;
		}
		
		function toString(pArg) {
			if (typeof(pArg) == "string") {
				return pArg;
			} {
				return "";
			}
		}
		
    }
}
