function PhotoListView(pObjDiv) {
	var objDiv = pObjDiv;
	objDiv = pObjDiv;
	objDiv.style.position = "absolute";
	objDiv.style.left = "0px";
	objDiv.style.top = "0px";
	objDiv.style.width = "960px";
	objDiv.style.height = "540px";
//	objDiv.style.display = "none";
	objDiv.style.visibility = "hidden";

	var iFocus = null;
	
	this.show = function() {
//		objDiv.style.display = "block";
		objDiv.style.visibility = "visible";
	}

	this.hide= function() {
//		objDiv.style.display = "none";		
		objDiv.style.visibility = "hidden";
	}
	
	this.clear= function() {
		WIDGET.putInnerHTML(objDiv, "");
	}
	
	this.focus = function(pPosition) {
		iFocus.focus(pPosition);
	}
	
	this.blur = function(pPosition) {
		iFocus.blur(pPosition);
	}
	
	this.request = function(pList, pFocusMapper) {
		iFocus = pFocusMapper;
		WIDGET.putInnerHTML(objDiv, generateHTML(pList));
	}
	
	var strName = "";
	var strCreated = "";
	
	this.setup = function(pAlbum) {
		strName = pAlbum.name;
		strCreated = pAlbum.created;
	}
	
	var Style = {
		Photo : { width : "138px", height : "109px", 'background' : "no-repeat center center" },
		Focus  : { width : "148px", height : "119px"}
	}
	
	var Photo = [
		[[267,90],[431,90],[595,90],[759,90],[768,90]],
		[[267,225],[431,225],[595,225],[759,225],[768,225]],
		[[267,360],[431,360],[595,360],[759,360],[768,360]]
		];
	var Focus = [
		[[262,85],[426,85],[590,85],[754,85],[763,85]],
		[[262,220],[426,220],[590,220],[754,220],[763,220]],
		[[262,355],[426,355],[590,355],[754,355],[763,355]]
	];
	
	function generateHTML(pList) {
		var strHTML = "";

		// Component header
		var HeaderName = {left:"445px",top:"26px",width:"300px",'text-align':"center",height:"20px",color:"#FFFFFF",font:"16px bold"};
		strHTML += Util.addDiv(Util.getStyle(HeaderName), SID_MIX_ADDED.Replace(Util.getTime2(strCreated)));
		var HeaderStyle = { left : "257px", top: "26px", width: "188px", height: "20px", color : "#FFFFFF", 'font' : "16px bold", 'overflow': 'hidden','white-space':'nowrap','text-overflow':"ellipsis"};
		strHTML += Util.addDiv(Util.getStyle(HeaderStyle),strName);

		var HeaderIndex1 = {right:"20px",top:"17px",width:"200px",height:"20px",color:"#FFFFFF",font:"16px",'text-align':"right"};
		strHTML += Util.addDiv(Util.getStyle(HeaderIndex1),FBID_PHOTOS + " ("+iFocus.getItemLength()+")");
		var HeaderIndex2 = {right:"20px",top:"34px",width:"200px",height:"20px",color:"#FFFFFF",font:"19px bold",'text-align':"right"};
		strHTML += Util.addDiv(Util.getStyle(HeaderIndex2),iFocus.getCurrentPage()+"/"+iFocus.getTotalPage());

		if (pList instanceof Array && pList[0] instanceof Array && pList[0] .length == 0) {
			var NoImage = {left:"509px",top:"142px",width:"144px",height:"180px",'background-image':"url(Resource/images/icon_exclamation.png)"};
			var NoTitle = {left:"381px",top:"352px",width:"400px",height:"180px",color:"#1b1b1b",font:" 30px",'text-align':"center"};
			var NoText = {left:"381px",top:"396px",width:"400px",height:"180px",color:"#4f4f4f",font:"18px",'text-align':"center"};
			strHTML += Util.addDiv(Util.getStyle(NoImage),"");
			strHTML += Util.addDiv(Util.getStyle(NoTitle),SID_NO_ALBUMS);
			return strHTML;
		}

		// Component Start : Scroll
		var nTotalPages = iFocus.getTotalPage();
		var nCurrentPages = iFocus.getCurrentPage() - 1;
		if (nTotalPages > 1) {

			strHTML += Util.getScrollBar({	
				currentPage : nCurrentPages, totalPage : nTotalPages,
				left : 917, top : 103, width : 4, height : 348,
				backgroundSrc : "Resource/images/viewmode_scroll_bg02.png",
				barSrc : "Resource/images/viewmode_scroll.png"
			});

			Style.ScrollUp = { width: "13px", height: "8px" };
			Style.ScrollDown = {width: "13px",height: "8px" };

			strHTML += Util.addImage("left:912px;top:85px;"+Util.getStyle(Style.ScrollUp),"Resource/images/viewmode_arrow_up.png");
			strHTML += Util.addImage("left:912px;top:461px;"+Util.getStyle(Style.ScrollDown),"Resource/images/viewmode_arrow_down.png");
		}
		// Component End : Scroll

		var lineLength = pList.length;
		var itemLength = 0;
		for (var lineIdx = 0; lineIdx < lineLength; lineIdx++) {
			itemLength = pList[lineIdx].length;
			for (var itemIdx = 0; itemIdx < itemLength; itemIdx++) {
				strHTML += "<div style = '"+Util.getStyle(Style.Photo)+"left:"+Photo[lineIdx][itemIdx][0]+"px;top:"+Photo[lineIdx][itemIdx][1]+"px;background-image:url("+pList[lineIdx][itemIdx].src+");'></div>";
//				strHTML += "<img src = '"+pList[lineIdx][itemIdx].src+"' style = '"+Util.getStyle(Style.Photo)+"left:"+Photo[lineIdx][itemIdx][0]+"px;top:"+Photo[lineIdx][itemIdx][1]+"px;'></div>";
				strHTML += iFocus.addDiv({row:lineIdx,col:itemIdx},null,Util.getStyle(Style.Focus)+"left:"+Focus[lineIdx][itemIdx][0]+"px;top:"+Focus[lineIdx][itemIdx][1]+"px;",FocusOnFocus,FocusOnBlur);
			}
		}
		//FBTrace(strHTML);
		return strHTML;
	}
	
	function FocusOnFocus(pObj) {
//		FBTrace("FocusOnFocus " + pObj);
//		pObj.style.backgroundImage = "url(Resource/images/photolist_focus.png)";
		pObj.style.backgroundImage = "url(Resource/images/facebook_highlight02.png)";
	}
	
	function FocusOnBlur(pObj) {
//		FBTrace("FocusOnBlur " + pObj);
		pObj.style.backgroundImage = "url()";		
	}
}
