function VideoListData() {
	var userID = "";
    var completeFn = null;

    this.request = function(pUserID, pCompleteFn){
		userID = pUserID;
		Instance.Loading.open();
		/*Start Interactive Device*/
		iRemoteFB.showLoading("Loading Data");
		/*End Interactive Device */
        completeFn = pCompleteFn;
        
        Instance.API.fql.query(function(pXMLHttpRequest){
            OnLoadData(pXMLHttpRequest);
        }, Instance.API.createAPIParams({
			query : "SELECT vid, owner, title, src, description, thumbnail_link, embed_html, updated_time, created_time FROM video WHERE owner= "+pUserID,
			format : "JSON"
		}));
        
    }
    function OnLoadData(pXMLHttpRequest){

        if (!Instance.Main.checkNetworkError(pXMLHttpRequest)) return;

		FBTrace(pXMLHttpRequest.responseText);
        var objResponse = Util.DecodeJSON(pXMLHttpRequest.responseText);

		var objResponseLength = objResponse.length;
		var objMedia = null;
		var objMediaLength = 0;
		var arrResult = [];
		
		for (var objectIdx = 0; objectIdx < objResponseLength; objectIdx++) {
			arrResult.push({
				post_id : objResponse[objectIdx].vid,
				name : objResponse[objectIdx].title,
				desc : objResponse[objectIdx].description,
				thumbnail : objResponse[objectIdx].thumbnail_link,
				source_url :  objResponse[objectIdx].src,
				created_time : objResponse[objectIdx].created_time,
				body : objResponse[objectIdx]
			});
		}
		Instance.Loading.close();
		/*Start Interactive Device*/
		iRemoteFB.hideLoading();
		/*End Interactive Device*/
		if (arrResult.length > 0) {
			// In case there are results
			completeFn(arrResult);
		} else {
			// In case there is no result
			completeFn(false);
		}
    }
}