function StreamTextFull(pViewInstance, pDataInstance, pReturnFn) {
	var _this_ = this;
	var returnFn = pReturnFn;
	var content = null;
	
	var iView = pViewInstance;
	var iData = pDataInstance;
	
	var streamMode = 0;
	
	this.open = function(pContent, pMode) {
		streamMode = pMode;
		content = pContent;
		Instance.Main.popupHelpNavi();
        Instance.Main.setKeyHandler(keyHandler, "StreamTextFull");
		iView.show();
		iView.update(pContent, streamMode);
	}
	
	this.close = function() {
		iView.hide();
	}
	
	function keyHandler(pKeyCode){
		switch (pKeyCode) {
			case TV.KEY_RIGHT:
			case TV.KEY_PANEL_VOL_DOWN:
				break;
			case TV.KEY_LEFT:
			case TV.KEY_PANEL_VOL_UP:
				break;
			case TV.KEY_UP:
			case TV.KEY_WHEELUP:
			case TV.KEY_PANEL_CH_UP:
				break;
			case TV.KEY_DOWN:
			case TV.KEY_WHEELDOWN:
			case TV.KEY_PANEL_CH_DOWN:
				break;
			case TV.KEY_ENTER:
				break;
			case TV.KEY_RED:
				if (content.actor_id != Instance.Main.getLoginID() || streamMode == Facebook.Define.NEWSFEED || !content.attribution) return Facebook.Define.Block;
				iView.hide();
                   /* Start Interactive Device */
				iRemoteFB.confirmcancelrequestpopup(SID_WANT_DELETE_LIST_MSG);
                   /*End Interactive Device */
				Instance.Popup.enter({
	                title: SID_DELETE,
	                message: SID_WANT_DELETE_LIST_MSG,
	                buttons: [{ caption: SID_YES, value: true },{ caption: SID_NO_FOR_CONTENT, value: false}]
	            }, function(pReturn) {
					if (pReturn) {
						iData.request(content.post_id,deleteCallback);
					} else {
						iView.show();
					}
				});
				return Facebook.Define.Block;
				break;			
			case TV.KEY_BLUE:
				_this_.close();
				Instance.Frame.open(content.actor_id, Facebook.Define.Menu.WALL);
				break;			
			case TV.KEY_RETURN:
				returnPrevious();
				break;				
				
			default:
				break;
		}
	}

	function deleteCallback(pReturn) {
		FBTrace(pReturn);
		_this_.close();
		if (pReturn == Facebook.Define.Success) {
	        returnFn(Facebook.Define.Update);
		}
		else {
	        returnFn(Facebook.Define.None);
		}
	}

	function returnPrevious(pType){
		_this_.close();
           /* Start Interactive Device */
	     iRemoteFB.textFullflag = 0;
		
	        if(streamingMode == 12){
			if( iRemoteFB.statusUpdateFlag == 1){
	                	iRemoteFB.onLoadStatusUpdate(NewsFeedArray);
	            	}else{
				iRemoteFB.showNews(iRemoteFB.GlobalPList,iRemoteFB.GlobalMode);
			}
	        }else  if(streamingMode == 13){
				iRemoteFB.showWall(iRemoteFB.GlobalPList,iRemoteFB.GlobalMode);
	        }
               /*End Interactive Device */
        	returnFn(Facebook.Define.None);
    	}
	

}
