function StreamVideoDetailView(pObjDiv) {
	var objDiv = pObjDiv;
	objDiv = pObjDiv;
	objDiv.style.position = "absolute";
	objDiv.style.left = "0px";
	objDiv.style.top = "0px";
	objDiv.style.width = "960px";
	objDiv.style.height = "540px";
	objDiv.style.visibility = "hidden";''

	var objCurrentTime = null;
	var objTotalTime = null;
	
	var objVolumeDiv = null;
	var objVolumeIconDiv = null;
	var strVolumeDiv = "_StreamVideoDetailView_Volume_";
	var strVolumeIconDiv = "_StreamVideoDetailView_VolumeIcon_";
	
	var strPlayIconImage = "_StreamVideoDetailView_PlayIconImage_";
	
	this.show = function() {
		objDiv.style.visibility = "visible";
//		_$("facebookFreeDiv").style.visibility = "visible";
	}

	this.hide= function() {
		objDiv.style.visibility = "hidden";		
//		_$("facebookFreeDiv").style.visibility = "hidden";
		this.playHelp.hide();
		Instance.GMF.BDFrontPanelDisplay(FRONT_DISPLAY_ONLINE);
	}
	
	this.request = function(pVideo) {
		WIDGET.putInnerHTML(objDiv, generateHTML(pVideo));
		objCurrentTime = _$("_StreamVideoDetailView_CurrentTime_");
		objTotalTime = _$("_StreamVideoDetailView_TotalTime_");
		this.playHelp.init();
		this.playHelp.show();
	}
	
	this.setTime = function(pTime) {
		var objTime = Util.getSeperateTime(Math.round(pTime/10)*10); // Round-up(1th)
		objCurrentTime.innerHTML = objTime.hour+":"+objTime.min+":"+objTime.sec;
		Instance.GMF.BDFrontPanelTime(parseInt(objTime.hour,10), parseInt(objTime.min,10), parseInt(objTime.sec,10));
	}

	this.setTotalTime = function(pTime) {
		var objTime = Util.getSeperateTime(Math.round(pTime/10)*10); // Round-up(1th)
		objTotalTime.innerHTML = objTime.hour+":"+objTime.min+":"+objTime.sec;
	}
	
	var Style = {
		Index : 	{},
		Frame : {left:"45px",top:"118px",width:"424px",height:"328px",'background-image':"url(Resource/images/profile_video_frame.png)"},
		TotalTime : {left:"155px",top:"89px",width:"200px",height:"30px",color:"#FFFFFF",font:"17px bold",'text-align':"left"},
		CurTime : {left:"69px",top:"89px",width:"200px",height:"30px",color:"#FFFFFF",font:"17px bold",'text-align':"left"},
		TimePart : {left:"140px",top:"92px",width:"6px",height:"15px"},
		Date : {left:"53px",top:"450px",width:"200px",height:"30px",color:"#1b1b1b",font:"16px bold",'text-align':"left"},
		Play: {left:"249px",top:"281px",width:"27px",height:"35px"},
		PlayIcon : {left:"48px",top:"91px"},
		VolumeIcon : {left:"417px",top:"91px",width:"14px",height:"15px",visibility : "hidden"},
		VolumeNum : {left:"433px",top:"89px",width:"30px",height:"30px",color:"#FFFFFF",font:"17px bold",'text-align':"center",visibility : "hidden"}
	}
	
	this.setVolumeOSD = function() {
		objVolumeDiv = _$(strVolumeDiv);
		objVolumeIconDiv = _$(strVolumeIconDiv);

		objVolumeDiv.style.visibility = "visible";
		objVolumeIconDiv.style.visibility = "visible";
		
		if (Instance.Audio.getMute()) {
			objVolumeDiv.innerHTML = "";
			objVolumeIconDiv.src = "Resource/images/mute_icon.png";

			if (StreamVideoDetailView.instanceTimer) clearTimeout(StreamVideoDetailView.instanceTimer);
		}
		else {
			objVolumeDiv.innerHTML = Instance.Audio.getVolume();
			objVolumeIconDiv.src = "Resource/images/volume_icon.png";

			if (StreamVideoDetailView.instanceTimer) clearTimeout(StreamVideoDetailView.instanceTimer);
			StreamVideoDetailView.instanceTimer = setTimeout(function(){
				objVolumeDiv.style.visibility = "hidden";
				objVolumeIconDiv.style.visibility = "hidden";
			},1000)
		}
	}

	// Control help navi on player
	// Deprecated 20091215
	this.playHelp = {
		objImage : null,
		strImageID : "_StreamVideoDeatilView_PlayerHelp_Image_",
		
		// Initilize 
		init : function() {
//			var objFreeDiv = _$("facebookFreeDiv");
//			objFreeDiv.style.visibility = "visible";
//			objFreeDiv.innerHTML = Util.addImage(Util.getStyle(Style.Play),"Resource/images/profile_video_play.png",this.strImageID);
//			this.objImage = _$(this.strImageID);
		},
		
		// Show play help
		show : function() {
//			this.objImage.style.visibility = "visible";
		},

		// Hide play help		
		hide : function() {
//			this.objImage.style.visibility = "hidden";			
		},
		
		// Clear play help		
		clear : function() {
//			WIDGET.putInnerHTML(_$("facebookFreeDiv"),"");
		},

		// Set play help				
		set : function(pStatus) {
			switch(pStatus) {
				case Facebook.Define.Pause : 
//					this.objImage.src = "Resource/images/profile_video_pause.png";
					Util.ScreenSaver.on();
					Instance.GMF.BDFrontPanelDisplay(FRONT_DISPLAY_PAUSE);
					_$(strPlayIconImage).src = "Resource/images/profile_video_pause02.png";
					break;
				case Facebook.Define.Play : 
//					this.objImage.src = "Resource/images/profile_video_play.png";
					Util.ScreenSaver.off();
					Instance.GMF.BDFrontPanelDisplay(FRONT_DISPLAY_PLAY);
					_$(strPlayIconImage).src = "Resource/images/profile_video_play02.png";
					break;
				case Facebook.Define.Stop : 
//					this.objImage.src = "Resource/images/profile_video_play.png";
					Util.ScreenSaver.on();
					Instance.GMF.BDFrontPanelDisplay(FRONT_DISPLAY_STOP);
					_$(strPlayIconImage).src = "Resource/images/profile_video_stop02.png";
					break;
				default : 
					break;
			}
		}
	}
	
	function generateHTML(pVideo) {
		var strHTML = "";

		// Component header
		var userObject = Instance.Frame.getUser();
		var HeaderName = {left:"45px",top:"68px",width:"415px",height:"20px",color:"#FFFFFF",font:"16px bold", 'overflow': 'hidden','white-space':'nowrap','text-overflow':"ellipsis" };
		strHTML += Util.addDiv(Util.getStyle(HeaderName), (userObject.name ? userObject.name + "'s Video - " : "") +  pVideo.name);

		strHTML += Util.addDiv(Util.getStyle(Style.Frame),"");
		strHTML += Util.addDiv(Util.getStyle(Style.TotalTime),Util.moldTime(pVideo.length),"_StreamVideoDetailView_TotalTime_");
		strHTML += Util.addDiv(Util.getStyle(Style.CurTime),"00:00:00","_StreamVideoDetailView_CurrentTime_");
		strHTML += Util.addImage(Util.getStyle(Style.TimePart),"Resource/images/time_part.png");
		strHTML += Util.addDiv(Util.getStyle(Style.Date),SID_MIX_ADDED.Replace(Util.getTime2(pVideo.created_time)));
		strHTML += Util.addImage(Util.getStyle(Style.PlayIcon),"Resource/images/profile_video_play02.png",strPlayIconImage);
		strHTML += Util.addImage(Util.getStyle(Style.VolumeIcon),"Resource/images/volume_icon.png",strVolumeIconDiv);
		strHTML += Util.addDiv(Util.getStyle(Style.VolumeNum),"0",strVolumeDiv);
		
		//FBTrace(strHTML);
		return strHTML;
	}
}

StreamVideoDetailView.instanceTimer = null;