function StreamYourMind(pDataInstance, pReturnFn) {
	var _this_ = this;
	
	var iData = pDataInstance;
	var returnFn = pReturnFn;
	
	this.enter = function() {
		Instance.Multiline.open(SID_WHATS_ON_YOUR_MIND, "", returnControl);
	}
	
	function returnControl(pResult) {
		if (pResult) {
			Instance.Main.preventKeyEvent();
			iData.request(pResult, function(pResult, pMsg){
				Instance.Main.releaseKeyEvent();
				if (pResult == Facebook.Define.Success)
					returnFn(Facebook.Define.Update, pMsg);
				else if (pResult == Facebook.Define.Fail) {
                      /* Start Interactive Device */
					iRemoteFB.errormsgPopup(pMsg);
                      /*End Interactive Device */
					Instance.Popup.enter({
			            title: SID_POST_TO_MY_PROFILE,
			            message: pMsg,
			            buttons: [{	 caption: SID_OK,	value: true }]
			        }, function(){
						returnFn(Facebook.Define.Cancel);
						facebookKeyHandler.focus();
					});
				}
			});
			return;
		}
		returnFn(Facebook.Define.Cancel);
		facebookKeyHandler.focus();
	}
		
    this.returnControl = function (pResult) {
		if (pResult) {
			Instance.Main.preventKeyEvent();
			iData.request(pResult, function(pResult, pMsg){
				Instance.Main.releaseKeyEvent();
				if (pResult == Facebook.Define.Success)
					returnFn(Facebook.Define.Update);
				else if (pResult == Facebook.Define.Fail) {
					  /* Start Interactive Device */
					iRemoteFB.errormsgPopup(pMsg);
                      /* End Interactive Device */
					Instance.Popup.enter({
			            title: SID_POST_TO_MY_PROFILE,
			            message: pMsg,
			            buttons: [{	 caption: SID_OK,	value: true }]
			        }, function(){
						returnFn(Facebook.Define.Cancel);
						facebookKeyHandler.focus();
					});
				}
			});
			return;
		}
		returnFn(Facebook.Define.Cancel);
		facebookKeyHandler.focus();
	}
    
	function keyHandler(pKeyCode) {
		switch(pKeyCode) {
			case TV.KEY_RIGHT :
			case TV.KEY_PANEL_VOL_DOWN :
				break;
			case TV.KEY_LEFT :
			case TV.KEY_PANEL_VOL_UP :
				break;
			case TV.KEY_UP :
			case TV.KEY_WHEELUP :
			case TV.KEY_PANEL_CH_UP :
				break;
			case TV.KEY_DOWN :
			case TV.KEY_WHEELDOWN :
			case TV.KEY_PANEL_CH_DOWN :
				break;
			case TV.KEY_FF :
				break;
			case TV.KEY_RW :
				break;				
			case TV.KEY_ENTER :
				break;
			case TV.KEY_RETURN : 
				break;
			default :
				break;
		}
	}
}