function StreamYourMindData(pPostID) {
	var postID = pPostID;
    var completeFn = null;

    this.request = function(pData, pCompleteFn){
		Instance.Loading.open();
          /* Start Interactive Device */
	        iRemoteFB.showLoading("Loading Data");
              /* End Interactive Device */
        completeFn = pCompleteFn;
        
        Instance.API.stream.publish(function(pXMLHttpRequest){
            OnLoadData(pXMLHttpRequest);
        }, Instance.API.createAPIParams({
			target_id : Instance.Frame.getFrameUserID(),
            message: pData,
            format: "JSON"
        }));
    }

    function OnLoadData(pXMLHttpRequest){
				
        if (!Instance.Main.checkNetworkError(pXMLHttpRequest)) return;
		
		FBTrace(pXMLHttpRequest.responseText);
		var objResponse = Util.DecodeJSON(pXMLHttpRequest.responseText);
		Instance.Loading.close();
          /* Start Interactive Device */
    		iRemoteFB.hideLoading();
              /* End Interactive Device */
		if (objResponse.error_code) {
			completeFn(Facebook.Define.Fail, objResponse.error_msg);
		} else {
			completeFn(Facebook.Define.Success, objResponse);
		}
    }
}
