function CommentsData(pID, pIDType){
    var completeFn = null;
    
    this.request = function(pCompleteFn){
        completeFn = pCompleteFn;
		
        var strMultiQuery = "";
		if (pIDType == Facebook.Define.IDTYPE_OBJECT) {
			strMultiQuery = '{\"comments\": \"SELECT object_id, fromid, time, text FROM comment WHERE object_id=\''+pID+'\'\",\"profile\" : \"SELECT uid, name, pic_square FROM user WHERE uid IN (SELECT fromid FROM #comments)\"}';	
		} else {
			strMultiQuery = '{\"comments\": \"SELECT post_id, fromid, time, text FROM comment WHERE post_id=\''+pID+'\'\",\"profile\" : \"SELECT uid, name, pic_square FROM user WHERE uid IN (SELECT fromid FROM #comments)\"}';
		}

        Instance.API.fql.multiquery(function(pXMLHttpRequest){
            commentsOnComplete(pXMLHttpRequest);
        }, Instance.API.createAPIParams({
            queries: strMultiQuery,
            format: "JSON"
        }));
        
    }
    
    function commentsOnComplete(pXMLHttpRequest){

        if (!Instance.Main.checkNetworkError(pXMLHttpRequest)) return;
		
//        FBTrace(pXMLHttpRequest.responseText);
        var objResponse = Util.DecodeJSON(pXMLHttpRequest.responseText);
		
        var objComments = null;
		var objProfile = null;
		
		if (objResponse[0].name == "comments") {
			objComments = objResponse[0].fql_result_set;
			objComments = Util.reverseArray(objComments);
		}

		if (objResponse[1].name == "profile")	{
			objProfile = objResponse[1].fql_result_set;
		}
		var refProfile = {};
		var objProfileLength = objProfile.length;
		for (var profileIdx = 0; profileIdx < objProfileLength; profileIdx++) {
            refProfile[objProfile[profileIdx].uid] = {
                name: objProfile[profileIdx].name,
                pic_square: objProfile[profileIdx].pic_square
            };
		}

		var objCommentsLength = objComments.length;
		var tID = "";
		for (var commentsIdx = 0; commentsIdx < objCommentsLength; commentsIdx++) {
			tID = objComments[commentsIdx].fromid;
			if (!refProfile[tID]) continue;
			objComments[commentsIdx].pic_square = refProfile[tID].pic_square;
			objComments[commentsIdx].name = refProfile[tID].name;
		}
		
        completeFn(objComments);
    }
}
