var sessionInfo = {};

var objDate = new Date();

function FacebookAPI(pApiKey, pApiSecret, pApiServer){
	var $this = this;
    var apiKey = pApiKey;
    var apiSecret = pApiSecret;
    var apiServer = pApiServer;
	
	// Use mutiple XMLHttpRequest object
	var XMLHttpRequestPool = new Array(4);
	var currentXHRIdx = 0;
	for (var xhrIdx = 0; xhrIdx < XMLHttpRequestPool.length;xhrIdx++) {
		XMLHttpRequestPool[xhrIdx] = NETSocket.getXMLHttpRequest();
	}
		
    var wzXMLHttpRequest = null;
	
    var sessionInfo = { activate : false, key : "", secret : "" }
	
	this.setSessionValue = function(pSessionKey,pSessionSecret,pSessionUid) {
		sessionInfo.activate = true;
		sessionInfo.key = pSessionKey;
		sessionInfo.secret = pSessionSecret;
		sessionInfo.uid = pSessionUid;
	}

	this.setSessionInfo = function(pObj) {
		for (var key in pObj) {
			sessionInfo[key] = pObj[key];
		}
	}

	// Admin API
	this.application= {
		'getPublicInfo' : function(pCallback, pParams) {
			request("application.getPublicInfo", pParams.toArray(), pCallback);
		}
	}
		
	// Admin API
	this.auth = {
		'createToken' : function(pCallback, pParams) {
			request("auth.createToken", pParams.toArray(), pCallback);
		},
		'getSession' : function(pCallback, pParams) {
			request("auth.getSession", pParams.toArray(), pCallback);
		},
		'login' : function(pCallback, pParams) {
			request("auth.login", pParams.toArray(), pCallback);
		},
		'logout' : function() {
			request("auth.logout", pParams.toArray(), pCallback);
		}
	}
	
	// Comments API
    this.comments = {
        'add' : function(pCallback, pParams){
			request("comments.add", pParams.toArray(), pCallback);
        },
        'get' : function(pCallback, pParams){
            request("comments.get", pParams.toArray(), pCallback);
        },
        'remove' : function(pCallback, pParams){
			request("comments.remove", pParams.toArray(), pCallback);
        }
    }
	
	// Data API
    this.data = {
        'getCookies' : function(pCallback, pParams){
			request("data.getCookies", pParams.toArray(), pCallback);
        },
        'setCookie' : function(pCallback, pParams){
            request("data.setCookie", pParams.toArray(), pCallback);
        }
    }
	
	// Events API
    this.events = {
        'cancel' : function(pCallback, pParams){
			request("events.cancel", pParams.toArray(), pCallback);
        },
        'create' : function(pCallback, pParams){
            request("events.create", pParams.toArray(), pCallback);
        },
        'edit' : function(pCallback, pParams){
            request("events.edit", pParams.toArray(), pCallback);
        },
        'get' : function(pCallback, pParams){
            request("events.get", pParams.toArray(), pCallback);
        },
        'getMembers' : function(pCallback, pParams){
            request("events.getMembers", pParams.toArray(), pCallback);
        },
        'rsvp' : function(pCallback, pParams){
            request("events.rsvp", pParams.toArray(), pCallback);
        }
    }
	
	// Friends API
    this.friends = {
        'areFriends' : function(pCallback, pParams){
			request("friends.areFriends", pParams.toArray(), pCallback);
        },
        'get' : function(pCallback, pParams){
            request("friends.get", pParams.toArray(), pCallback);
        },
        'getAppUsers' : function(pCallback, pParams){
			request("friends.getAppUsers", pParams.toArray(), pCallback);
        },
        'getLists' : function(pCallback, pParams){
            request("friends.getLists", pParams.toArray(), pCallback);
        },
        'confirm' : function(pCallback, pParams){
            request("friends.confirm", pParams.toArray(), pCallback);
        }
    }

	// Friends API
    this.fql = {
        'query' : function(pCallback, pParams){
			request("fql.query", pParams.toArray(), pCallback);
        },
        'multiquery' : function(pCallback, pParams){
            request("fql.multiquery", pParams.toArray(), pCallback);
        }
    }

	// Groups API
    this.groups = {
        'get' : function(pCallback, pParams){
			request("groups.get", pParams.toArray(), pCallback);
        },
        'getMembers' : function(pCallback, pParams){
			request("groups.getMembers", pParams.toArray(), pCallback);
		}
    }

	// Links API
    this.links = {
        'get' : function(pCallback, pParams){
			request("links.get", pParams.toArray(), pCallback);
        },
        'post' : function(pCallback, pParams){
			request("links.post", pParams.toArray(), pCallback);
		}
    }
	
	// Notes API
    this.notes = {
        'create': function(pCallback, pParams){
			request("notes.create", pParams.toArray(), pCallback);
        },
        'delete': function(pCallback, pParams){
			request("notes.delete", pParams.toArray(), pCallback);
		},
	    'edit': function(pCallback, pParams){
			request("notes.edit", pParams.toArray(), pCallback);
        },
        'get': function(pCallback, pParams){
			request("notes.get", pParams.toArray(), pCallback);
		}
    }
	
	// Notifications API
    this.notifications = {
        'get': function(pCallback, pParams){
			request("notifications.get", pParams.toArray(), pCallback);
        },
        'send': function(pCallback, pParams){
			request("notifications.send", pParams.toArray(), pCallback);
		},
	    'sendEmail': function(pCallback, pParams){
			request("notifications.sendEmail", pParams.toArray(), pCallback);
        }
    }
	
	// Pages API
    this.pages = {
        'getInfo': function(pCallback, pParams){
			request("pages.getInfo", pParams.toArray(), pCallback);
        },
        'isAdmin': function(pCallback, pParams){
			request("pages.isAdmin", pParams.toArray(), pCallback);
		},
	    'isAppAdded': function(pCallback, pParams){
			request("pages.isAppAdded", pParams.toArray(), pCallback);
        },
	    'isFan': function(pCallback, pParams){
			request("pages.isFan", pParams.toArray(), pCallback);
        }
    }
	
	// Photos API
	this.photos = {
		'addTag' : function(pCallback, pParams) {
			request("photos.addTag", pParams.toArray(), pCallback);
		},
		'createAlbum' : function(pCallback, pParams) {
			request("photos.createAlbum", pParams.toArray(), pCallback);
		},
		'get' : function(pCallback, pParams) {
			request("photos.get", pParams.toArray(), pCallback);
		},	
		'getAlbums' : function(pCallback, pParams) {
			request("photos.getAlbums", pParams.toArray(), pCallback);
		},
		'getTags' : function(pCallback, pParams) {
			request("photos.getTags", pParams.toArray(), pCallback);
		},
		'upload' : function(pCallback, pParams) {
			request("photos.getTags", pParams.toArray(), pCallback);
		}
	}
	
	// Profile API
	this.profile = {
		'getInfo' : function(pCallback, pParams) {
			request("profile.getInfo", pParams.toArray(), pCallback);
		},
		'getInfoOptions' : function(pCallback, pParams) {
			request("profile.getInfoOptions", pParams.toArray(), pCallback);
		},
		'setFBML' : function(pCallback, pParams) {
			request("profile.setFBML", pParams.toArray(), pCallback);
		},	
		'setInfo' : function(pCallback, pParams) {
			request("profile.setInfo", pParams.toArray(), pCallback);
		},
		'setInfoOptions' : function(pCallback, pParams) {
			request("profile.setInfoOptions", pParams.toArray(), pCallback);
		}
	}
	
	// Status API
	this.status = {
		'get' : function(pCallback, pParams) {
			request("status.get", pParams.toArray(), pCallback);
		},
		'set'  : function(pCallback, pParams) {
			request("status.set", pParams.toArray(), pCallback);
		}
	}
	
	// Notes API
	this.stream = {
		'addComment' : function(pCallback, pParams) {
			request("stream.addComment", pParams.toArray(), pCallback);
		},
		'addLike' : function(pCallback, pParams) {
			request("stream.addLike", pParams.toArray(), pCallback);
		},
		'get' : function(pCallback, pParams) {
			request("stream.get", pParams.toArray(), pCallback);
		},
		'getComments' : function(pCallback, pParams) {
			request("stream.getComments", pParams.toArray(), pCallback);
		},
		'getFilters' : function(pCallback, pParams) {
			request("stream.getFilters", pParams.toArray(), pCallback);
		},
		'publish' : function(pCallback, pParams) {
			request("stream.publish", pParams.toArray(), pCallback);
		},
		'remove' : function(pCallback, pParams) {
			request("stream.remove", pParams.toArray(), pCallback);
		},
		'removeComment' : function(pCallback, pParams) {
			request("stream.removeComment", pParams.toArray(), pCallback);
		},
		'removeLike' : function(pCallback, pParams) {
			request("stream.removeLike", pParams.toArray(), pCallback);
		}
	}
	
	// User API
	this.users = {
		'getInfo' : function(pCallback, pParams) {
			request("users.getInfo", pParams.toArray(), pCallback);
		},
		'getLoggedInUser' : function(pCallback, pParams) {
			request("users.getLoggedInUser", pParams.toArray(), pCallback);
		},
		'getStandardInfo' : function(pCallback, pParams) {
			request("users.getStandardInfo", pParams.toArray(), pCallback);
		},
		'hasAppPermission'  : function(pCallback, pParams) {
			request("users.hasAppPermission", pParams.toArray(), pCallback);
		},
		'isAppUser' : function(pCallback, pParams) {
			request("users.isAppUser", pParams.toArray(), pCallback);
		},
		'isVerified'  : function(pCallback, pParams) {
			request("users.isVerified", pParams.toArray(), pCallback);
		},
		'setStatus' : function(pCallback, pParams) {
			request("users.setStatus", pParams.toArray(), pCallback);
		}
	}
	
	// User API
	this.pages = {
		'getInfo': function(pCallback, pParams){
			request("pages.getInfo", pParams.toArray(), pCallback);
		}
	}
	
	// Graph API
	this.GraphAPI = function(pQuery, pCallback) {
		var sQueryURL = "https://graph.facebook.com/" + pQuery + "?access_token="+sessionInfo.access_token;
		
		currentXHRIdx = (currentXHRIdx < (XMLHttpRequestPool.length - 1)) ? currentXHRIdx + 1 : 0;
		XMLHttpRequestPool[currentXHRIdx].destroy();
		XMLHttpRequestPool[currentXHRIdx] = NETSocket.getXMLHttpRequest();
        wzXMLHttpRequest = XMLHttpRequestPool[currentXHRIdx];
	
		NETSocket.setURL(wzXMLHttpRequest, "GET", sQueryURL, "", pCallback, null);
	    NETSocket.setRequestHeader(wzXMLHttpRequest, "Content-type", "application/x-www-form-urlencoded;charset=utf-8");
    	NETSocket.callURL(wzXMLHttpRequest);			
	}
	
	// Graph API
	this.Graph = {};
	
	this.Graph.writeComment = function(pCallback, pPostID, pParam) {writeComment(pCallback, pPostID, pParam);};
	
	function writeComment(pCallback, pID, pParam) {
		$this.request("/"+pID+"/comments", $this.createAPIParams(pParam), function(pXMLHttpRequest){
			alert(pXMLHttpRequest.responseText);
			pCallback(pXMLHttpRequest);
        }, "POST");
	}

	this.request = function(pItemID, pParams, pCallback, pMethod) {
		GraphRequest(pItemID, pParams.toArray(), pCallback, pMethod);
	}

	this.createAPIParams = function(pParams){
		var objAPIParams = new this.APIParams(pParams);
		return objAPIParams;
	}

	this.APIParams = function(pParams) {
		this.objParams = pParams;
	};
	
	this.APIParams.prototype.toArray = function() {
		var retArray = [];
		for (var name in this.objParams) {
			value = this.objParams[name];
			retArray[retArray.length] = name + "=" + this.objParams[name];
		}
		return retArray;
	}

	 var arrParams = [];

    function request(pMethod, pArrParams, pCallbackFn, pTryout){
		alert("FaceBookAPI -> request " + pArrParams);
		var objRequest = { method : pMethod, params : pArrParams, callback : pCallbackFn, tryout : pTryout ? pTryout : 0	}
        if (pArrParams instanceof Array) {
            var tArrLength = pArrParams.length;
            for (var index = 0; index < tArrLength; index++) {
                arrParams.push(pArrParams[index]);
            }
        } else FBTrace("[Error] pArrParams is not an Array");
		
        arrParams.push("api_key=" + apiKey);
		arrParams.push("call_id=" + objDate.getTime());
        arrParams.push("method=" + pMethod);
        arrParams.push("v=" + API_VERSION);
		
        if (sessionInfo.activate) 
            arrParams.push("session_key=" + sessionInfo.key);
		
		var arrSig = getSignature(arrParams);
        arrParams.push("sig=" + arrSig);
		
        var strQuery = getParamString(arrParams, true);
		
		//FBTrace("API Call[" + pMethod + "] with " + strQuery);
		
		currentXHRIdx = (currentXHRIdx < (XMLHttpRequestPool.length - 1)) ? currentXHRIdx + 1 : 0;
		XMLHttpRequestPool[currentXHRIdx].destroy();
		XMLHttpRequestPool[currentXHRIdx] = NETSocket.getXMLHttpRequest();
		gCurrentXHRIdx = currentXHRIdx;
        wzXMLHttpRequest = XMLHttpRequestPool[currentXHRIdx];

		var strRESTServer = ( pMethod != "auth.login" ) ? apiServer : "https://api.facebook.com/restserver.php";

		// If browser XMLHttpRequest timeout doesn't work,
		// generate Widget timeout

		FacebookAPI.nTimeStamp = (new Date()).getTime();
		FBTrace_("Request Timestamp : "+FacebookAPI.nTimeStamp);
		
		var timeoutFn = (function(pTimeStamp){
			return function(){
				if (pTimeStamp == FacebookAPI.nTimeStamp) {
					alert("[Facebook Notice] Widget XMLHttpRequest timeout occured.");
					if (objRequest.tryout > 3) {
						pCallbackFn(false);
					}
					else {
						request(objRequest.method, objRequest.params, objRequest.callback, objRequest.tryout + 1);
					}
				}
			}
		})(FacebookAPI.nTimeStamp);
		
        var instanceTimeout = setTimeout(function(){
            timeoutFn();
        }, 35 * 1000);

		var callbackFn = (function(pTimeStamp, pInstanceTimeout){
			return function(pXMLHttpRequest){
				// If this callback is from last request, do this
				if (pTimeStamp == FacebookAPI.nTimeStamp) {
					if (pInstanceTimeout) clearTimeout(pInstanceTimeout);
					if (pXMLHttpRequest) {
						pCallbackFn(pXMLHttpRequest);
					} else {
						if (objRequest.tryout > 3) {
							pCallbackFn(false);
						}
						else {
							request(objRequest.method, objRequest.params, objRequest.callback, objRequest.tryout + 1);
						}
					}
				}
			}
		})(FacebookAPI.nTimeStamp, instanceTimeout);
		
		NETSocket.setURL(wzXMLHttpRequest, "POST", strRESTServer, "", callbackFn, null);
	    NETSocket.setRequestHeader(wzXMLHttpRequest, "Content-type", "application/x-www-form-urlencoded;charset=utf-8");
		
		if (pMethod == "fql.multiquery" || pMethod == "fql.query") {
    	    NETSocket.callURL(wzXMLHttpRequest, encodeURI(strQuery));			
		} else {
	        NETSocket.callURL(wzXMLHttpRequest, strQuery);			
		}
		
		// Array Reset
		arrParams.length = 0;
    }

	this.cancelRequest = function() {
		if (wzXMLHttpRequest)
			FBTrace("FacebookAPI : cancelRequest");
			wzXMLHttpRequest.abort();
	}

    function getSignature(pArrParams){
        var tStr = getParamString(pArrParams, false);
		
        if (sessionInfo.activate) 
            tStr += sessionInfo.secret;
        else 
            tStr += apiSecret;
        return MD5(tStr);
    }
    
    function getParamString(pArrParams, pbSeperate){
        var tArrParams = [];
        var tArrParamsLength = pArrParams.length;
        for (var index = 0; index < tArrParamsLength; index++) {
            tArrParams[index] = pArrParams[index];
			if (!pbSeperate) tArrParams[index] = tArrParams[index].replace("%26","&").replace("%2B","+");
        }
        tArrParams.sort();
		var retStr = (pbSeperate ? tArrParams.join("&") : tArrParams.join(""));
		
        return retStr;
    }
	
	function GraphRequest(pItemID, pArrParams, pCallbackFn, pMethod, pTryout){
		alert("GraphRequest");
		
		var objRequest = { itemID : pItemID, params : pArrParams, callback : pCallbackFn, method : pMethod, tryout : pTryout ? pTryout : 0	}
       
        if (pArrParams instanceof Array) {
            var tArrLength = pArrParams.length;
            for (var index = 0; index < tArrLength; index++) {
                arrParams.push(pArrParams[index]);
            }
        } else alert("[Error] pArrParams is not an Array");
		
        arrParams.push("api_key=" + apiKey);
		arrParams.push("call_id=" + objDate.getTime());
        arrParams.push("v=" + "1.0");
		
        if (sessionInfo.activate) 
            arrParams.push("session_key=" + sessionInfo.key);
		
		var arrSig = getSignature(arrParams);
        arrParams.push("sig=" + arrSig);
		
        var strQuery = getParamString(arrParams, true);
		
		alert("API Call[" + pItemID + "] with " + strQuery);
		
		currentXHRIdx = (currentXHRIdx < (XMLHttpRequestPool.length - 1)) ? currentXHRIdx + 1 : 0;
		XMLHttpRequestPool[currentXHRIdx].destroy();
		XMLHttpRequestPool[currentXHRIdx] = NETSocket.getXMLHttpRequest();
		gCurrentXHRIdx = currentXHRIdx;
        wzXMLHttpRequest = XMLHttpRequestPool[currentXHRIdx];

		var strRESTServer = "https://graph.facebook.com" + pItemID;
		strRESTServer += "?access_token=" + sessionInfo.access_token;
		
		if (pMethod == "DELETE") {
			strRESTServer += "&method=delete";
			pMethod = "POST";
		}

		// If browser XMLHttpRequest timeout doesn't work,
		// generate Widget timeout

		FacebookAPI.nTimeStamp = (new Date()).getTime();
//		alert("Request Timestamp : "+FacebookAPI.nTimeStamp);
		
		var timeoutFn = (function(pTimeStamp){
			return function(){
				if (pTimeStamp == FacebookAPI.nTimeStamp) {
					alert("[Facebook Notice] Widget XMLHttpRequest timeout occured.");
					if (objRequest.tryout > 0) {
						pCallbackFn(false);
					}
					else {
						request(objRequest.method, objRequest.params, objRequest.callback, objRequest.method, objRequest.tryout + 1);
					}
				}
			}
		})(FacebookAPI.nTimeStamp);
		
        var instanceTimeout = setTimeout(function(){
            timeoutFn();
        }, 35 * 1000);

		var callbackFn = (function(pTimeStamp, pInstanceTimeout){
			return function(pXMLHttpRequest){
				// If this callback is from last request, do this
				if (pTimeStamp == FacebookAPI.nTimeStamp) {
					if (pInstanceTimeout) clearTimeout(pInstanceTimeout);
					if (pXMLHttpRequest) {
						pCallbackFn(pXMLHttpRequest);
					} else {
						if (objRequest.tryout > 0) {
							pCallbackFn(false);
						}
						else {
							request(objRequest.itemID, objRequest.params, objRequest.callback, objRequest.method, objRequest.tryout + 1);
						}
					}
				}
			}
		})(FacebookAPI.nTimeStamp, instanceTimeout);
		
		NETSocket.setURL(wzXMLHttpRequest, pMethod ?  pMethod : "GET", strRESTServer, "", callbackFn, null);
	    NETSocket.setRequestHeader(wzXMLHttpRequest, "Content-type", "application/x-www-form-urlencoded;charset=utf-8");
   	    NETSocket.callURL(wzXMLHttpRequest, encodeURI(strQuery));			
		
		// Array Reset
		arrParams.length = 0;
    }
}

// To identify Facebook API Request
FacebookAPI.nTimeStamp = null;