function FacebookMenuView(pObjDiv){
	var objDiv = pObjDiv;
	var objMenuType = {};
	var arrMenuPreload = [];
	var objMenuPreload = {};
	var bFocused = false;
	
    this.update = function(pMenu, pCurPage, pTotalPage){
        var depth = 0;
		objIDDepth = {};
		objMenuType = {};
		arrMenuPreload = [];
		objMenuPreload = {};
		
		//WIDGET.putInnerHTML(objDiv, recurUpdate(depth, pMenu));
		WIDGET.putInnerHTML(objDiv, generateMenu(pMenu, pCurPage, pTotalPage));
		objectPreload();
    }

	this.show = function() {
		objDiv.style.visibility = "visible";
	}
	
	this.hide = function() {
		objDiv.style.visibility = "hidden";
	}
	
	function objectPreload() {
		var menuLength = arrMenuPreload.length;
		for (var menuIdx = 0; menuIdx < menuLength; menuIdx++) {
			objMenuPreload[arrMenuPreload[menuIdx]] = document.getElementById(getDivID(arrMenuPreload[menuIdx]));
		}
	}
	
	function generateMenu(pMenu, pCurPage, pTotalPage){
        var strHTML = "";
        var menuLength = pMenu.length;
		var bSubmenuOpen = false;
		
        for (var menuIdx = 0; menuIdx < menuLength; menuIdx++) {
			arrMenuPreload.push(pMenu[menuIdx].id);
			objMenuType[pMenu[menuIdx].id] = pMenu[menuIdx].type;
			if (pMenu[menuIdx].type == Facebook.Define.MenuType.ITEM && !bSubmenuOpen) {
				bSubmenuOpen = true;
				var nCategory = countCategory();
				if (nCategory > 1) {
					strHTML += "<div id = 'MenuUI_SecondDepth_BG' style = 'width:224px;height:268px;background-image:url(Resource/images/catagory_bg.png);'>";
				} else if (nCategory == 1){
					strHTML += "<div id = 'MenuUI_SecondDepth_BG' style = 'width:224px;height:367px;background-image:url(Resource/images/catagory_bg02.png);'>";
				} else {
					strHTML += "<div id = 'MenuUI_SecondDepth_BG' style = 'width:224px;height:367px;background-image:url(Resource/images/catagory_bg03.png);'>";
				}
				strHTML += "<table><tr><td height = '15px'></td></tr></table>";
			} else if (pMenu[menuIdx].type == Facebook.Define.MenuType.CATEGORY && bSubmenuOpen) {
				bSubmenuOpen = false;
				strHTML += "</div>";
			}
			strHTML += makeMenuHTML(pMenu[menuIdx].id, pMenu[menuIdx].caption, pMenu[menuIdx].icon, pMenu[menuIdx].type);
		}
		if (bSubmenuOpen) strHTML += "</div>";
		if (pTotalPage > 1) {
			var Scroll = { width: "14px", height: "10px" };
			if(pCurPage == 0) {
				strHTML += Util.addImage("left:105px;top:402px;" + Util.getStyle(Scroll), "Resource/images/catagory_icon9_2.png");
			} else if (pCurPage == (pTotalPage - 1)){
				strHTML += Util.addImage("left:105px;top:7px;" + Util.getStyle(Scroll), "Resource/images/catagory_icon9_1.png");
			} else {
				strHTML += Util.addImage("left:105px;top:402px;" + Util.getStyle(Scroll), "Resource/images/catagory_icon9_2.png");
				strHTML += Util.addImage("left:105px;top:7px;" + Util.getStyle(Scroll), "Resource/images/catagory_icon9_1.png");
			}
		}
		
		function countCategory() {
			var nCnt = 0;
			for (var idx = 0; idx < pMenu.length; idx++) {
				if (pMenu[idx].type == Facebook.Define.MenuType.CATEGORY) {
					nCnt++;
				}
			}
			return nCnt;
		}
		
		return strHTML;
    }
	
	function makeMenuHTML(pID, pCaption, pIcon, pType){
		var strHTML = "";
		switch(pType) {
			case Facebook.Define.MenuType.CATEGORY : 
		        strHTML += "<div id ='"+getDivID(pID)+"' style = 'width:224px;height:49px;background-image:url(Resource/images/catagory_btn.png);font-size:18px;'>";
		        strHTML += "<table><tr><td height = '49px' width = '10px' style = 'vertical-align:middle;'>";
		        strHTML += "</td><td style = 'vertical-align:middle;'><div style = 'height:24px;padding-right:5px;width:157px;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;'>" + pCaption + "</div></td></tr></table>";
		        strHTML += "</div>";
				break;
			case Facebook.Define.MenuType.ITEM : 
		        strHTML += "<div id ='"+getDivID(pID)+"' style = 'color:#FFFFFF;width:216px;height:29px;font-size:16px;'>";
				strHTML += "<table><tr><td width = '5px'></td><td style = 'width:25px;text-align:center;'><img src = 'Resource/images/"+pIcon+"' style = 'vertical-align:middle;padding-right:5px;'></td>";
				strHTML += "<td style = 'padding-top:3px;width:5px;vertical-align:middle;'><div style = 'width:175px;overflow:hidden;white-space:nowrap;text-overflow:ellipsis;'>"+pCaption+"</div></td>";
				strHTML += "</tr></table>";
				strHTML += "</div>";
				break;
			default :
				break;
		}
        return strHTML;
    }

    function getDivID(pID){
        return "FacebookMenuView_" + pID;
    }
	
	function getMenuType(pID) {
		return objMenuType[pID];
	}
	
	this.isFocused = function() {
		return bFocused;
	}
	
    this.focus = function(pID){
		bFocused = true;
		var objItem = objMenuPreload[pID];
		switch(getMenuType(pID)) {
			case Facebook.Define.MenuType.CATEGORY : 
				objItem.style.backgroundImage = "url(Resource/images/catagory_focus1.png)";
				break;
			case Facebook.Define.MenuType.ITEM :
				objItem.style.backgroundImage = "url(Resource/images/catagory_focus2.png)";
				objItem.style.color = "#64A7E9";
				break;
			default :
				break;
		}
    }
    
    this.blur = function(pID){
		bFocused = false;
        var objItem = objMenuPreload[pID];
		switch(getMenuType(pID)) {
			case Facebook.Define.MenuType.CATEGORY : 
				objItem.style.backgroundImage = "url(Resource/images/catagory_btn.png)";
				break;
			case Facebook.Define.MenuType.ITEM :
				objItem.style.backgroundImage = "url(Resource/images/blank.png)";
				objItem.style.color = "#FFFFFF";
				break;
			default :
				break;
		}
    }

    this.select = function(pID){
        var objItem = objMenuPreload[pID];
		objItem.style.backgroundImage = "url()";		
    }
    
	
	this.hide = function() {
		objDiv.style.visibility = "hidden";
	}
	
	this.show = function() {
		objDiv.style.visibility = "visible";
	}
}