function PhotoAlbumView(pObjDiv) {
	var objDiv = pObjDiv;
	objDiv = pObjDiv;
	objDiv.style.position = "absolute";
	objDiv.style.left = "0px";
	objDiv.style.top = "0px";
	objDiv.style.width = "960px";
	objDiv.style.height = "540px";
//	objDiv.style.display = "none";
	objDiv.style.visibility = "hidden";

	var iFocus = null;
	
	this.show = function() {
//		objDiv.style.display = "block";
		objDiv.style.visibility = "visible";
        	 prevMode = 101;
	}

	this.hide= function() {
//		objDiv.style.display = "none";		
		objDiv.style.visibility = "hidden";
	}
	
	this.clear= function() {
		WIDGET.putInnerHTML(objDiv, "");
	}
	
	this.focus = function(pPosition) {
		iFocus.focus(pPosition);
	}
	
	this.blur = function(pPosition) {
		iFocus.blur(pPosition);
	}
	
	this.request = function(pList, pFocusMapper) {
		iFocus = pFocusMapper;
		WIDGET.putInnerHTML(objDiv,generateHTML(pList));
	}
	
//	var PhotoFrameWidth = 220;
//	var PhotoFrameHeight = 148;

	var PhotoFrameWidth = 138;
	var PhotoFrameHeight = 138;
	
	var Style = {
		Photo : { width : PhotoFrameWidth+"px", height : PhotoFrameHeight+"px", 'background' : "#FFFFFF no-repeat center center" },
		PhtotoFrame : { width:PhotoFrameWidth+"px", height:PhotoFrameHeight+"px", overflow:"hidden" },
		Focus  : { width : (PhotoFrameWidth+10)+"px", height : (PhotoFrameHeight+10)+"px"},
		PhotoLen : { width : "210px", height : "17px", font : "16px bold", color : "#434343" },
		Name : { 'padding-right' : "5px", width : "150px", height : "17px", font : "16px bold", color : "#434343", 'overflow': 'hidden','white-space':'nowrap','text-overflow':"ellipsis" }
	}
	
//	var Photo = [
//		[[238,85],[460,85],[682,85],[652,79],[792,79]],
//		[[238,282],[460,282],[682,282],[652,280],[792,280]]
//		];
//	var Focus = [
//		[[238,85],[460,85],[682,85],[652,79],[792,79]],
//		[[238,282],[460,282],[682,282],[652,280],[792,280]]
//	];
//	var PhotoLen = [
//		[[240,238],[462,238],[684,238],[654,225],[794,225]],
//		[[240,435],[462,435],[684,435],[654,426],[794,426]]
//	];
//	var Name = [
//		[[240,255],[462,255],[684,255],[653,242],[793,242]],
//		[[240,452],[462,452],[684,452],[653,443],[793,443]]
//	];
	
	var Photo = [
		[[267,90],[431,90],[595,90],[759,90],[792,79]],
		[[267,291],[431,291],[595,291],[759,291],[792,280]]
		];
	var Focus = [
		[[262,85],[426,85],[590,85],[754,85],[792,79]],
		[[262,286],[426,286],[590,286],[754,286],[792,280]]
	];
	var PhotoLen = [
		[[267,236],[431,236],[595,236],[759,236],[794,225]],
		[[267,437],[431,437],[595,437],[759,437],[794,426]]
	];
	var Name = [
		[[267,253],[431,253],[595,253],[759,253],[793,242]],
		[[267,454],[431,454],[595,454],[759,454],[793,443]]
	];
	
	function generateHTML(pList) {
		var strHTML = "";
		
		// Component header
		var userObject = Instance.Frame.getUser();
		var HeaderName = {left:"257px",top:"26px",width:"200px",height:"20px",color:"#FFFFFF",font:"16px bold"};
		strHTML += Util.addDiv(Util.getStyle(HeaderName), userObject.name+" " + SID_ALBUMS_);
		
		if ((pList instanceof Array && pList[0] instanceof Array && pList[0] .length == 0) || !pList) {
			var NoImage = {left:"509px",top:"142px",width:"144px",height:"180px",'background-image':"url(Resource/images/icon_exclamation.png)"};
			var NoTitle = {left:"381px",top:"352px",width:"400px",height:"180px",color:"#1b1b1b",font:" 30px",'text-align':"center"};
			var NoText = {left:"381px",top:"396px",width:"400px",height:"180px",color:"#4f4f4f",font:"18px",'text-align':"center"};
			strHTML += Util.addDiv(Util.getStyle(NoImage),"");
			strHTML += Util.addDiv(Util.getStyle(NoTitle),SID_NODATA);
			return strHTML;
		}

		// Component Start : Scroll
		var nTotalPages = iFocus.getTotalPage();
		var nCurrentPages = iFocus.getCurrentPage() - 1;
		if (nTotalPages > 1) {

			strHTML += Util.getScrollBar({	
				currentPage : nCurrentPages, totalPage : nTotalPages,
				left : 917, top : 103, width : 4, height : 348,
				backgroundSrc : "Resource/images/viewmode_scroll_bg02.png",
				barSrc : "Resource/images/viewmode_scroll.png"
			});

			Style.ScrollUp = { width: "13px", height: "8px" };
			Style.ScrollDown = {width: "13px",height: "8px" };

			strHTML += Util.addImage("left:912px;top:85px;"+Util.getStyle(Style.ScrollUp),"Resource/images/viewmode_arrow_up.png");
			strHTML += Util.addImage("left:912px;top:461px;"+Util.getStyle(Style.ScrollDown),"Resource/images/viewmode_arrow_down.png");
		}
		// Component End : Scroll

		var HeaderIndex1 = {right:"20px",top:"17px",width:"200px",height:"20px",color:"#FFFFFF",font:"16px",'text-align':"right"};
		strHTML += Util.addDiv(Util.getStyle(HeaderIndex1),SID_ALBUMS_ + " ("+iFocus.getItemLength()+")");
		var HeaderIndex2 = {right:"20px",top:"34px",width:"200px",height:"20px",color:"#FFFFFF",font:"19px bold",'text-align':"right"};
		strHTML += Util.addDiv(Util.getStyle(HeaderIndex2),iFocus.getCurrentPage()+"/"+iFocus.getTotalPage());
		
		var lineLength = pList.length;
		var itemLength = 0;
		var objImageSize = {};
		
		for (var lineIdx = 0; lineIdx < lineLength; lineIdx++) {
			itemLength = pList[lineIdx].length;
			for (var itemIdx = 0; itemIdx < itemLength; itemIdx++) {
				objImageSize = calculateAdjustImageSize(PhotoFrameWidth,PhotoFrameHeight,pList[lineIdx][itemIdx].width,pList[lineIdx][itemIdx].height);
				strHTML += "<div style = '"+"left:"+Photo[lineIdx][itemIdx][0]+"px;"+"top:"+Photo[lineIdx][itemIdx][1]+"px;"+Util.getStyle(Style.PhtotoFrame)+"'>";
				strHTML += "<div style = 'background:#FFFFFF;width:"+PhotoFrameWidth+"px;height:"+PhotoFrameHeight+"px;overflow:hidden'>";
				strHTML += Util.addImage("position:absolute;left:"+((PhotoFrameWidth-objImageSize.width)/2)+"px;top:"+Math.round((PhotoFrameHeight-objImageSize.height)/2)+"px;width:"+objImageSize.width+"px;height:"+objImageSize.height+"px;",pList[lineIdx][itemIdx].src);
				strHTML += "</div>";
				strHTML += "</div>";
				strHTML += iFocus.addImage({row:lineIdx,col:itemIdx},FBID_PHOTOS + " (" + pList[lineIdx][itemIdx].size + ")",Util.getStyle(Style.PhotoLen)+"left:"+PhotoLen[lineIdx][itemIdx][0]+"px;top:"+PhotoLen[lineIdx][itemIdx][1]+"px;",PhotoLenOnFocus,PhotoLenOnBlur);
				strHTML += iFocus.addDiv({row:lineIdx,col:itemIdx},FBID_PHOTOS + " (" + pList[lineIdx][itemIdx].size + ")",Util.getStyle(Style.PhotoLen)+"left:"+PhotoLen[lineIdx][itemIdx][0]+"px;top:"+PhotoLen[lineIdx][itemIdx][1]+"px;",PhotoLenOnFocus,PhotoLenOnBlur);
				strHTML += iFocus.addDiv({row:lineIdx,col:itemIdx},pList[lineIdx][itemIdx].name,Util.getStyle(Style.Name)+"left:"+Name[lineIdx][itemIdx][0]+"px;top:"+Name[lineIdx][itemIdx][1]+"px;'",NameOnFocus,NameOnBlur);
				strHTML += iFocus.addDiv({row:lineIdx,col:itemIdx},null,Util.getStyle(Style.Focus)+"z-index:1;left:"+Focus[lineIdx][itemIdx][0]+"px;top:"+Focus[lineIdx][itemIdx][1]+"px;",FocusOnFocus,FocusOnBlur);
			}
		}
		return strHTML;
	}
	
	function calculateAdjustImageSize(pTargetWidth, pTargetHeight, pOriginalWidth, pOriginalHeight) {
		var objResult = { width : 0, height : 0	};
		
//		if (!((pOriginalWidth < pTargetWidth) && (pOriginalHeight < pTargetHeight))) {
//			// Calculate original image ratio
//			if ((pTargetHeight / pTargetWidth) > (pOriginalHeight / pOriginalWidth)) {
//				// Fit to width
//				objResult.width = pTargetWidth;
//				objResult.height = Math.round(pOriginalHeight * (pTargetWidth / pOriginalWidth));
//			} else {
//				// Fit to height
//				objResult.height = pTargetHeight;
//				objResult.width = Math.round(pOriginalWidth * (pTargetHeight / pOriginalHeight));
//			}			
//		}
		
		if (pTargetWidth < pOriginalWidth) {
			objResult.width = pTargetWidth;
			objResult.height = Math.round(pOriginalHeight * (pTargetWidth / pOriginalWidth));
		} else {
			objResult.width = pOriginalWidth;
			objResult.height = pOriginalHeight;
		}
		
		return objResult;
	}
	
	function FocusOnFocus(pObj) {
		pObj.style.backgroundImage = "url(Resource/images/facebook_highlight03.png)";
	}
	
	function FocusOnBlur(pObj) {
		pObj.style.backgroundImage = "url()";		
	}
	
	function PhotoLenOnFocus(pObj) {
		pObj.style.color = "#da2479";		
	}
	
	function PhotoLenOnBlur(pObj) {
		pObj.style.color = "#434343";
	}
	
	function NameOnFocus(pObj) {	
		pObj.style.color = "#da2479";	
	}
	
	function NameOnBlur(pObj) {
		pObj.style.color = "#434343";		
	}	
}
