function PhotoFullView(pObjDiv) {
	var _this_  = this;

	var objDiv = pObjDiv;
	objDiv.style.position = "absolute";
	objDiv.style.left = "0px";
	objDiv.style.top = "0px";
	objDiv.style.width = "960px";
	objDiv.style.height = "540px";
	objDiv.style.visibility = "hidden";
	objDiv.style.overflow = "hidden";

	var iFocus = null;
	
	this.show = function() {
		objDiv.style.visibility = "visible";
		_$("facebookHelpDiv").style.backgroundImage = "url(Resource/images/navi_help_bg02.png)";
	}

	this.hide= function() {
		_$("facebookHelpDiv").style.backgroundImage = "url(Resource/images/navi_help_bg.png)";
		Instance.Main.hideBlankPage();
		objDiv.style.visibility = "hidden";
		Instance.GMF.stop();
		Instance.GMF.clearScreen();
	}
	
	this.request = function(pObjPhoto, pFocusMapper) {
		iFocus = pFocusMapper;
		if (Instance.GMF.getState() == GMFPlayer.PLAYING) {
			Instance.GMF.stop();
		}
		Instance.Main.showBlankPage();
		WIDGET.putInnerHTML(objDiv,generateHTML(pObjPhoto));
	}
	
	this.showHelpNavi = function() {
		Instance.Main.showHelpNavi();
		var tObj = _$("_facebook_PhotoFullView_Help_");
		if (tObj) tObj.style.visibility = "visible";
	}
	
	this.hideHelpNavi = function() {
		Instance.Main.hideHelpNavi();
		var tObj = _$("_facebook_PhotoFullView_Help_");
		if (tObj) tObj.style.visibility = "hidden";
	}
	
	// [100423] Network error page
	this.showNetworkError = function() {
		var tObj = $('_facebook_PhotoFullView_network_error_');
		if (tObj) tObj.style.display = 'block';
	}
	
	var Style = {
		Header : {  left : "0px", top : "0px"},
		Logo : { left : "0px", top : "10px", width : "192px", height : "35px", 'text-align' : "center",color:"#FFFFFF",font : "16px"},
		Filename : { left : "192px", top : "10px", width : "180px", height : "35px", 'text-align' : "center",color:"#FFFFFF",font : "16px",'padding-left' : "5px",'padding-right' : "5px",'overflow': 'hidden','white-space':'nowrap','text-overflow':"ellipsis"},
		Resolution: { left : "384px", top : "10px", width : "192px", height : "35px", 'text-align' : "center",color:"#FFFFFF",font : "16px"},
		Date : { left : "576px", top : "10px", width : "192px", height : "35px", 'text-align' : "center",color:"#FFFFFF",font : "16px"},
		Page : { left : "768px", top : "10px", width : "192px", height : "35px", 'text-align' : "center",color:"#FFFFFF",font : "16px bold"},
		NetworkError : {display : 'none'},
		NetworkErrorIcon : { left : "408px", top : "137px", width : "144px", height : "177px"},
		NetworkErrorText : { left : "20px", top : "337px", width : "920px", 'text-align' : 'center'}
	}
	
	function generateHTML(pObjPhoto) {
		// adjust width, height for resolution
		var nWidth = Math.round(pObjPhoto.src_big_width/2);
		var nHeight  = Math.round(pObjPhoto.src_big_height/2);
		
		if (nWidth > 960) {
			nWidth = 960;
			nHeight = Math.round(nHeight * (960 / nWidth));
		} 
		if (nHeight > 540){
			nWidth = Math.round(nWidth * (540 / nHeight));
			nHeight = 540;
		}
	
		var nLeft = Math.round((960-nWidth)/2);
		var nTop = Math.round((540-nHeight)/2);
		
		var strHTML = "";
		var tempHTML = "";
		strHTML += "<div id = '_facebook_PhotoFullView_Help_' style = 'position:absolute;left:0px;top:0px;width:960px;height:540px;'>"
		strHTML += Util.addImage(Util.getStyle(Style.Header),"Resource/images/fullscreen_bg.png");
		strHTML += Util.addDiv(Util.getStyle(Style.Logo),"<img src = 'Resource/images/facebook_logo_02.png'>");
		strHTML += Util.addDiv(Util.getStyle(Style.Filename),pObjPhoto.caption ? pObjPhoto.caption.substr(0,20) : SID_NO_TITLE_PHOTOS);
		strHTML += Util.addDiv(Util.getStyle(Style.Resolution),pObjPhoto.src_big_width + "X" + pObjPhoto.src_big_height);
		strHTML += Util.addDiv(Util.getStyle(Style.Date),Util.getTime(pObjPhoto.modified));
		if (iFocus) {
			strHTML += Util.addDiv(Util.getStyle(Style.Page), iFocus.getIndex() + "/" + iFocus.getItemLength());
		}
		strHTML += "</div>";
		
		// [100423] Network error page
		var errorText = '';
		errorText += '<span style="font-size:30px;color:#FFFFFF;">'+SID_NO_INFORMATION+'</span>';
		errorText += '<br><br>';
		errorText += '<span style="font-size:18px;color:#F1EEEE;">'+SID_ALERT_NETWORKERROR_MSG+'</span>';
		var errorContents = '';
		errorContents += Util.addImage(Util.getStyle(Style.NetworkErrorIcon),'Resource/images/networkerror_image.png');
		errorContents += Util.addDiv(Util.getStyle(Style.NetworkErrorText), errorText);
		strHTML += Util.addDiv(Util.getStyle(Style.NetworkError, true), errorContents,'_facebook_PhotoFullView_network_error_');
		//
		
		Instance.Loading.open();	// be closed when Player occurs 'endDrawLoading' event.
            /* Start Interactive Device */
       		iRemoteFB.showLoading("Loading Data");
            /* End Interactive Device */
		// [DMS00740121] delay Player operation for loading popup timing prob.
		setTimeout(function(){
			Instance.GMF.play(pObjPhoto.src_big, nLeft, nTop, nWidth, nHeight);
		}, 0);
		
		return strHTML;
	}
}