function RequestListData(pUserID) {
	var userID = pUserID;
    var completeFn = null;
	var CONFIRM = 1;
	var IGNORE = 0;

    this.request = function(pCompleteFn){
		Instance.Loading.open();
        iRemoteFB.showLoading("Loading Data");
        completeFn = pCompleteFn;
        /*
        Instance.API.notifications.get(function(pXMLHttpRequest){
            OnLoadData(pXMLHttpRequest);
        }, Instance.API.createAPIParams({
            format: "JSON"
        }));
        */
        detailRequest();
    }
	
	this.confirm = function(pUid, pCompleteFn){
		Instance.Loading.open();
        /* Start Interactive Device */
        iRemoteFB.showLoading("Loading Data");
        /* End Interactive Device */
		completeFn = pCompleteFn;
		confirmRequest(CONFIRM, pUid);
	}
	this.ignore = function(pUid, pCompleteFn){
		Instance.Loading.open();
        /* Start Interactive Device */
        iRemoteFB.showLoading("Loading Data");
        /* End Interactive Device */
		completeFn = pCompleteFn;
		confirmRequest(IGNORE, pUid);
	}
	
/* Start Interactive Device */	
this.confirmRequestfromiPhone = function( pUid,completeFn){
    alert("confirming fredn request");
    this.confirm (pUid, completeFn);
    }
    this.ignoreRequestfromiPhone =  function( pUid,completeFn){
    alert("confirming fredn request");
    this.ignore (pUid, completeFn);
    }
/* End  Interactive Device */	
	function confirmRequest(pValue, pUid){
		Instance.API.friends.confirm(function(pXMLHttpRequest){
            OnConfirm(pXMLHttpRequest);
        }, Instance.API.createAPIParams({
            uid: pUid,
			confirm: pValue,
            format: "JSON"
        }));
	}
	
	function OnConfirm(pXMLHttpRequest){
		if (!Instance.Main.checkNetworkError(pXMLHttpRequest)) return;
		
		FBTrace(pXMLHttpRequest.responseText);
		
		var retValue = pXMLHttpRequest.responseText;		// result is true or false
		
		Instance.Loading.close();
        /* Start Interactive Device */
        iRemoteFB.hideLoading();
        /* End Interactive Device */
        completeFn(retValue);
	}
    
	function OnLoadData(pXMLHttpRequest){
		
        if (!Instance.Main.checkNetworkError(pXMLHttpRequest)) return;
		
        FBTrace(pXMLHttpRequest.responseText);
		var objResponse = Util.DecodeJSON(pXMLHttpRequest.responseText);
		var friendRequests = objResponse.friends_requests;
		var groupInvites = objResponse.group_invites;
		var eventInvites = objResponse.event_invites;
		Instance.Loading.close();
        /* Start Interactive Device */
        iRemoteFB.hideLoading();
        /* End Interactive Device */
        completeFn();
    }
	
	function detailRequest() {
		Instance.Loading.open();
        /* Start Interactive Device */
        iRemoteFB.showLoading("Loading Data");
        /* End Interactive Device */
        var strMultiQuery = '{\"friendRequest\" : \"SELECT uid_from  FROM friend_request WHERE uid_to = '+Instance.Main.getLoginID()+'\",\"profile\" : \"SELECT uid, name, pic_square FROM user WHERE uid IN (SELECT uid_from FROM #friendRequest)\"}';
		
        Instance.API.fql.multiquery(function(pXMLHttpRequest){
            OnLoadDetail(pXMLHttpRequest);
        }, Instance.API.createAPIParams({
            queries: strMultiQuery,
            format: "JSON"
        }));
	}
	
	function OnLoadDetail(pXMLHttpRequest){

        if (!Instance.Main.checkNetworkError(pXMLHttpRequest)) return;
        FBTrace(pXMLHttpRequest.responseText);
		var objResponse = Util.DecodeJSON(pXMLHttpRequest.responseText);
		var requestList = null;
		
		requestList = objResponse[1].fql_result_set;
		
		var requestLength = requestList.length;
		for (var requestIdx = 0; requestIdx < requestLength; requestIdx++) {
			requestList[requestIdx].name = (requestList[requestIdx].name != "") ? requestList[requestIdx].name : "Unknown";		// Unknown 예외처리긴한데, 다국어는?
			requestList[requestIdx].pic_square = (requestList[requestIdx].pic_square != null) ? requestList[requestIdx].pic_square : "http://static.ak.fbcdn.net/pics/q_silhouette.gif";
		}
		
		Instance.Loading.close();
        /* Start Interactive Device */
		iRemoteFB.hideLoading();
        /* End Interactive Device */
		if (requestList.length > 0)
			completeFn(requestList);
		else 
			completeFn(false);
	}
}
