function Stream(pViewInstance, pDataInstance, pReturnFn) {
	var _this_ = this;
	
	var userID = "";
	var iView = pViewInstance;
	var iData = pDataInstance;
	var returnFn = pReturnFn;
	
    streamView = iView;
    
    
	var objPages = [];
	var nRow = 6, nCol = 3;
	var iFocus = new FocusMapper("Stream",nRow, nCol);
    /* Start Interactive Device */
	iRemoteFB.streamFocus = iFocus ;
	var iStreamYourMind = new StreamYourMind(new StreamYourMindData(), StreamYourMindReturnFn);
    /*End Interactive Device */
	var iStreamShare = new StreamShare(new StreamShareView(_$("facebookStreamShareDiv")),new StreamShareData(),ShareCallbackFn);
	var iStreamVideoDetail = new StreamVideoDetail(new StreamVideoDetailView(_$("facebookStreamVideoDetailDiv")),null,returnListFn);
	var iPhotoFull = new PhotoFull(new PhotoFullView(_$("facebookPhotoFullDiv")),new PhotoFullData(),null,returnListFn);	
    var iCommentsList = new CommentsList(new CommentsListView(_$("facebookCommentsListDiv")), new CommentsListData(), UpdateCallbackFn);
	var iStreamTextFull = new StreamTextFull(new StreamTextFullView(_$("facebookStreamTextFullDiv")),new StreamDeleteData(),SubmenuCallbackFn);
	var objTotalStream = null;

	var instanceState = Facebook.Define.None;

	var bOpened = false;
	var bReady = false;
	var bOptionMode = false;
	var currentFilter = Stream.Define.All;
	var curOption = null;
    
	var streamMode = 0;
    IStreamTextFull = iStreamTextFull;
	
	
	/** 
	 * Encoding error. New description needed
	 * @return 	bOpened		
	 */
	this.isOpened = function(){
        return bOpened;
    }

	/** 
	 * Encoding error. New description needed
	 * @return 	bReady		
	 */
	this.isReady = function(){
        return bReady;
    }

	/** 
	 * Encoding error. New description needed
	 */
	this.open = function(pUserID, pOption) {
//		FBTrace("Stream Open Start");
		bOpened = true;
		bOptionMode = pOption ? true : false;
		curOption = pOption;
		
		userID = pUserID;
		
		iView.show();
		
		if (pOption) {
			if (changeFilter(pOption))
				bReady = true;
		} else {
			iData.request(userID, OnLoadData);
			currentFilter = Stream.Define.All;
		}
//		FBTrace("Stream Open End");
	}
	
	/** 
	 * Encoding error. New description needed
	 */
	this.close = function() {
//		FBTrace("Stream Close Start");
		bOpened = false;
		bReady = false;

		iView.clear();
		iView.hide();
//		FBTrace("Stream Close End");
	}

	/** 
	 * Encoding error. New description needed	 
	 */
	this.enter = function() {
		if (!bReady) {	 returnFn(); return; }
		
		Instance.Main.setKeyHandler(keyHandler,"Stream");
		iView.focus(iFocus.getFocus());
	}

	/** 
	 * Encoding error. New description needed
	 * @return		arrHelp		Help Navi ?�보�??��? Array
	 */
	function generateHelpNavi() {
		FBTrace("generateHelpNavi");
		var arrHelp = [];
		if (Instance.Frame.getType() == FacebookFrame.Define.ME) {
			if (!isWhatsOnYourMind())
				arrHelp[arrHelp.length] = {	image : HelpArea.Image.Green,		text : SID_COMMNET_M_ADD_COMMENT		};
			if (iFocus.getTotalPage() > 1)
				arrHelp[arrHelp.length] = {	image : HelpArea.Image.FFRW,		text : SID_PAGE_UP_DOWN	};				
			arrHelp[arrHelp.length] = {	image : HelpArea.Image.Return,	text : SID_RETURN			};
		} else if (Instance.Frame.getType() == FacebookFrame.Define.FRIEND) {
			if (!isWhatsOnYourMind())
				arrHelp[arrHelp.length] = {	image : HelpArea.Image.Green,		text : SID_COMMNET_M_ADD_COMMENT		};
			if (iFocus.getTotalPage() > 1)
				arrHelp[arrHelp.length] = {	image : HelpArea.Image.FFRW,		text : SID_PAGE_UP_DOWN	};				
			arrHelp[arrHelp.length] = {	image : HelpArea.Image.Return,	text : SID_RETURN			};
		} else {
			arrHelp[arrHelp.length] = {	image : HelpArea.Image.Return,	text : SID_RETURN			};
		}
		return arrHelp;
	}

	/** 
	 * Encoding error. New description needed
	 */
	function OnLoadData(pData, pFocus, pLastFocus) {
		if (!bOpened) return;

		streamMode = pData.mode;
		objTotalStream = pData.result;
		
		if (bOptionMode) {
        	NewsFeedArray = objTotalStream;
			changeFilter(curOption);
        	} else {
			generatePage(objTotalStream);
           	 if (streamMode == Facebook.Define.NEWSFEED) {
			showNewsDetails(objTotalStream, streamMode);
		 }
		else {
			showWallDetails(objTotalStream, streamMode);
		}
		iFocus.generate(objPages);
		bReady = (iFocus.getItemLength()) > 0 ? true : false;	
		requestPage(iFocus.getFocus().page);
      	}		
		if (pLastFocus == Stream.Define.RESET) {
			resetYourMindFocus();
		}
		else if (pLastFocus) {
				findLastFocus(pLastFocus);
				// Defect[P101014-0153] Redraw "page" after finding focus
				// Defect[P101014-0152] Redraw "Help Navi" after focus moves
				requestPage(iFocus.getFocus().page);
		}
		if (pFocus == true && Instance.Main.getKeyHandler() == "Stream") {
			iView.focus(iFocus.getFocus());
		}		
		if (instanceState == Facebook.Define.Processing) {
			instanceState = Facebook.Define.None;
		}
	}
    /*
        For Profile access
    */
    this.OnLoadDatafromIphone =function(pData, pFocus, pLastFocus) {
		if (!bOpened) return;

		streamMode = pData.mode;
		objTotalStream = pData.result;
		
		if (bOptionMode) {
			changeFilter(curOption);
		} else {
			generatePage(objTotalStream);
            showWallDetails(objTotalStream);  
			iFocus.generate(objPages);
			bReady = (iFocus.getItemLength()) > 0 ? true : false;	
			requestPage(iFocus.getFocus().page);
		}		
		if (pLastFocus == Stream.Define.RESET) {
			resetYourMindFocus();
		}
		else if (pLastFocus) {
				findLastFocus(pLastFocus);
		}
		if (pFocus == true && Instance.Main.getKeyHandler() == "Stream") {
			iView.focus(iFocus.getFocus());
		}		
		if (instanceState == Facebook.Define.Processing) {
			instanceState = Facebook.Define.None;
		}
	}    
    
    this.getiData = function(){
    return iData;
    }   
    
    function showNewsDetails(dataArray, mode){
     NewsFeedArray = dataArray;
     streamingMode = mode;
    }
     
    function showWallDetails(dataArray, mode){
        /* Start Interactive Device */
    	NewsFeedArray = dataArray;
        streamingMode = mode;                         
        /*End Interactive Device */
    }
	// TEMS2 Code : 20100409-0040
	// Reset focus after posting stream by "What's on your mind?"
	function resetYourMindFocus() {
		if (iFocus.isFocusable({page: 0, row: 3, col: 0})) {
			iFocus.setFocus({ page: 0, row: 3, col: 0 });
		} else if (iFocus.isFocusable({page: 0, row: 4, col: 0})) {
			iFocus.setFocus({ page: 0, row: 4, col: 0 });
		} else if (iFocus.isFocusable({page: 0, row: 1, col: 0})) {
			iFocus.setFocus({ page: 0, row: 1, col: 0 });
		}
		
		// Change help navi after posting
		Instance.Main.registHelpNavi(generateHelpNavi(),"Stream");
		Instance.Main.applyHelpNavi("Stream");
	}

	function findLastFocus(pLastFocus) {
		var pageLength = objPages.length;
		
		var objFirstPost = null;
		var objSecondPost = null;
		
		var objFocus = {};
		objFocus.col = pLastFocus.col;
		for (var pageIdx = 0; pageIdx < pageLength; pageIdx++) {
			objFirstPost = objPages[pageIdx][1] ? objPages[pageIdx][1] : null;
			objSecondPost = objPages[pageIdx][4] ? objPages[pageIdx][4] : null;
			if (objFirstPost && objFirstPost[0].data.post_id == pLastFocus.postID) {
				objFocus.row = pLastFocus.row > 2 ? pLastFocus.row - 3 : pLastFocus.row;
				objFocus.page = pageIdx;
				iFocus.setFocus(objFocus);
				break;
			} else if (objSecondPost && objSecondPost[0].data.post_id == pLastFocus.postID){
				objFocus.row = pLastFocus.row < 3 ? pLastFocus.row + 3 : pLastFocus.row;
				objFocus.page = pageIdx;	
				iFocus.setFocus(objFocus);
				break;
			}
		}
	}

	/** 
	 * Encoding error. New description needed
	 */
	function requestPage(pPage) {
		Instance.Main.registHelpNavi(generateHelpNavi(),"Stream");
		if (Instance.Main.getKeyHandler() == "Stream") {
			Instance.Main.applyHelpNavi("Stream");
		}
		var nCurMode = 0;
		if (currentFilter == Stream.Define.All) {
			if (streamMode == Facebook.Define.NEWSFEED) {
				nCurMode = Stream.Define.NEWSFEED;
			} else if (streamMode == Facebook.Define.WALL){
				nCurMode = Stream.Define.WALL;
			}
		} else {
			if (currentFilter == Stream.Define.Text) {
				nCurMode = Stream.Define.STATUS_UPDATES;
			} else if (currentFilter == Stream.Define.Photo) {
				nCurMode = Stream.Define.PHOTOS;
			} else if (currentFilter == Stream.Define.Video) {
				nCurMode = Stream.Define.VIDEOS;
			}
		}
		MODEoStream = nCurMode;
		if (iFocus.getItemLength() > 0) {
			iFocus.setPage(pPage);
			iView.request(objPages[pPage], iFocus, nCurMode);
			 /* Start Interactive Device */
			if(iRemoteFB.menuFlag == 1){
				iMenu.enter();
				iRemoteFB.menuFlag = 0;
			}
			 /* End Interactive Device */
		} else {
			bReady = false;
			iView.request(false, iFocus, nCurMode);
			iView.blur(iFocus.getFocus());
			returnFn();
		}
	}

	/** 
	 * Encoding error. New description needed
	 */
	function generatePage(pData, pFilter) {
		var dataLength = pData.length;
		var itemBuffer = [];
		var lineBuffer = [];
		var nPage = 0;
		var bShow = null;
		
		objPages = [];
		objPages[nPage] = [];
		
		var arrRow = null;
		var curStream = null;
		
		// What's on your mind?
		if (!pFilter || pFilter == Stream.Define.Text)
			pushWhatsOnYourMind();
	  
   		IStreamYourMind = iStreamYourMind ;
         
		for (var dataIdx = 0; dataIdx < dataLength; dataIdx++) {
            /* Start Interactive Device */
			curStream = pData[dataIdx];            
            iRemoteFB.testCurStream = curStream ;
            /*End Interactive Device */
			var nStreamType = Stream.Common.getStreamType(curStream);
			//FBTrace("Stream Type["+curStream.post_id+"] " + nStreamType);
			
			bShow = false;
			if (pFilter == Stream.Define.Text) {
				if (nStreamType == pFilter) bShow = true;
			} else if (pFilter == Stream.Define.Photo) {
				if (nStreamType == Stream.Define.Photo || nStreamType == Stream.Define.Album) bShow = true;
			} else if (pFilter == Stream.Define.Video) {
				if (nStreamType == Stream.Define.Video) bShow = true;
			} else {
				if (nStreamType == Stream.Define.Text || nStreamType == Stream.Define.Photo || nStreamType == Stream.Define.Album || nStreamType == Stream.Define.Video) bShow = true;
			}
			
			if (bShow) {
				if (objPages[nPage].length > 3) {
					objPages[++nPage] = [];
				}
				// 1st Line
				arrRow = [];
				// Go Profile Button
				// 20100409-0038 : Allow to go Profile in every case 
//				if (curStream.actor_id != iData.getID()) {
					arrRow[0] = {
						actor : function(curStream){
							return function(){
								iView.clear();
								Instance.Frame.open(curStream.actor_id, Facebook.Define.Menu.WALL);
							}
						}(curStream)
						, name : curStream.name
					};
//				} else {
//					arrRow[0] = {	 disable : true  }
//				}
				objPages[nPage].push(arrRow);
				
				// 2nd Line
				arrRow = [];
				arrRow[0] = {
					data : function(dataIdx){
						return pData[dataIdx];
					}(dataIdx)
				};
				if (nStreamType == Stream.Define.Video) {

                     curStream.attachment.media;
                     
					arrRow[0].actor = function(curStream){
						return function(){
							iView.hide();
							var objVideoData = {								
								post_id : curStream.post_id,
								name : curStream.attachment.name,
								length : curStream.attachment.properties[0] ? curStream.attachment.properties[0].text : "00:00",
								thumbnail : curStream.attachment.media[0].src,
								source_url :  curStream.attachment.media[0].video.source_url,
								created_time : curStream.created_time,
								singleMode : true,
								// Attach this stream data to body element (by DMS00503972)
								body : curStream
							};
                            /* Start Interactive Device */
                             iRemoteFB.GlobalVideoArray = objVideoData;
                             /*End Interactive Device */
							iStreamVideoDetail.enter(objVideoData, { postID : curStream.post_id, row : iFocus.getFocus().row, col : iFocus.getFocus().col });
						}
					}(curStream);
				} else if (nStreamType == Stream.Define.Album || nStreamType == Stream.Define.Photo) {
					var arrMedia = curStream.attachment.media;
					var mediaLength = arrMedia.length;
					IPhotoFull = iPhotoFull;
					for (var mediaIdx = 0; mediaIdx < mediaLength; mediaIdx++) {
						if (typeof(arrRow[mediaIdx]) != "object") arrRow[mediaIdx] = {};
						if (arrMedia[mediaIdx].type == "photo" || arrMedia[mediaIdx].type == "image") {
							arrRow[mediaIdx].actor = function(curStream, arrMedia, mediaIdx){
								return function(){
									iView.hide();
									var objPhoto = {
										type : Facebook.Define.Stream
										, pid : arrMedia[mediaIdx].photo.pid
										// Return Type is changed. (2011-01-11)
										, actor_id : arrMedia[mediaIdx].photo.owner
										, pic_square : curStream.pic_square
									}
									Instance.Frame.open(curStream.actor_id, Facebook.Define.Menu.PHOTOS);									
									//iPhotoFull.enter(objPhoto);
								}
							}(curStream, arrMedia, mediaIdx)
						} else if (arrMedia[mediaIdx].type == "link") {
							if (arrMedia[mediaIdx].href.search(/photo.php/) == -1) {
								arrRow[mediaIdx].actor = function(curStream){
									return function(){
										Instance.Frame.open(curStream.actor_id, Facebook.Define.Menu.PHOTOS);
									}
								}(curStream)
							} else {
								var strPID = arrMedia[mediaIdx].href.match(/pid=(\d*)/)[1];
								var strID = arrMedia[mediaIdx].href.match(/\Wid=(\d*)/)[1];
								arrRow[mediaIdx].actor = function(curStream, arrMedia, mediaIdx){
									return function(){
										iView.hide();
										var objPhoto = {
											type : Facebook.Define.Stream
											, pid : strID + "_" + strPID
											, actor_id : curStream.actor_id
											, pic_square : curStream.pic_square
										}
										iPhotoFull.enter(objPhoto);
									}
								}(curStream, arrMedia, mediaIdx)
							}
						}
					}
				} else if (nStreamType == Stream.Define.Text) {
					arrRow[0].actor = function(curStream, streamMode){
								return function(){                                    
                                    /* Start Interactive Device */
                                    iRemoteFB.openTextView(curStream, streamMode);
                                    /* End Interactive Device */
									iStreamTextFull.open(curStream, streamMode);
								}
							}(curStream, streamMode)
				}
				
				objPages[nPage].push(arrRow);
                /* Start Interactive Device */
				 IStreamVideoDetail  = iStreamVideoDetail ;
                 /* End Interactive Device */
                 / Interactive Device */
				// 3rd Line
				arrRow = [];
				// Comments Button
				if (curStream.comments.count > 0) {
					arrRow[0] = {
						data : curStream.comments.count,
						actor: function(curStream){
							return function(){
								iCommentsList.open(curStream.post_id, { postID : curStream.post_id, row : iFocus.getFocus().row, col : iFocus.getFocus().col });
							}
						}(curStream)
					};
				} else {
					arrRow[0] = { disable: true, data : 0 };
				}
				/* Start Interactive Device */
				ICommentList = iCommentsList ;
                /* End Interactive Device */
//				// Share Button
//				if (nStreamType == Stream.Define.Text) {
//					// Your Mind
//				} else {
//					arrRow[1] = {
//						actor: function(curStream){
//							return function(){
//								shareContents(curStream);
//							}
//						}(curStream)
//					}
//				}
				objPages[nPage].push(arrRow);
                IStreamShare = iStreamShare;
			} 
		}
		nTotalPages = objPages.length;
		
		function pushWhatsOnYourMind(){
			for (var idx = 0; idx < 3; idx++) {
				arrRow = [];
				if (idx == 0) {
					arrRow[0] = {
						data: Facebook.Define.ItemType.ACTOR,
						actor: function(){
							
                            iStreamYourMind.enter();
						}
					}
				}
				else {
					arrRow[0] = {
						data: Facebook.Define.ItemType.DUMMY,
						disable: true
					};
				}
				objPages[0].push(arrRow);
			}
		}
        /*Start Interactive Device */
        iRemoteFB.ShareStreamObjPages = objPages ;
        /* End Interactive Device */
	}

	/** 
	 * Share�??�한 Data 구성
	 * @param		pStream	Share???�용
	 */
    function shareContents(pStream){
        var curStream = pStream;
		
        var objShare = {
			src : curStream.attachment.media[0].src
			, type : curStream.attachment.fb_object_type
			, name : curStream.attachment.name
			, pic_square : curStream.pic_square
        };
        
		var strPID = "";
		
        switch (Stream.Common.getStreamType(curStream)) {
            case Stream.Define.Photo:
				objShare.name = curStream.message ? curStream.message : "";
				var mediaLength = curStream.attachment.media.length;
				var strPID = "";
				objShare.attachment = Util.copyObject(curStream.attachment);
				objShare.attachment.media[0].type = "image";
				objShare.attachment.media[0].src = curStream.attachment.media[0].src;
				objShare.attachment.media[0].href = objShare.attachment.media[0].href.replace("&","%26");
				delete objShare.attachment.href;
                break;
			case Stream.Define.Album:
				objShare.name = curStream.attachment.name ? curStream.attachment.name : "";
				var mediaLength = curStream.attachment.media.length;
				objShare.attachment = Util.copyObject(curStream.attachment);
				objShare.attachment.media[0].type = "image";
				objShare.attachment.media[0].src = curStream.attachment.media[0].src;
				objShare.attachment.media[0].href= objShare.attachment.href.replace("&","%26");
				objShare.attachment.media.length = 1;
				delete objShare.attachment.href;
                break;
            case Stream.Define.Video:
				objShare.attachment = Util.copyObject(curStream.attachment);
				objShare.attachment.media[0].src = curStream.attachment.media[0].src;
				objShare.attachment.media[0].video_src = curStream.attachment.media[0].video.source_url;
				objShare.attachment.media[0].preview_img = curStream.attachment.media[0].src;
				objShare.attachment.media[0].video_title = curStream.attachment.name;
		
				objShare.attachment.properties = {};
				objShare.attachment.properties[curStream.attachment.properties[0].name] = curStream.attachment.properties[0].text;
                break;
            default:
                break;
        }
		delete objShare.attachment.fb_object_id;
		delete objShare.attachment.description;
		objShare.attachment.share = "true";
		objShare.writter = curStream.name;
		
		instanceState = Facebook.Define.Processing;
		iStreamShare.enter(objShare);
    }

	/** 
	 * Encoding error. New description needed
	 */
	function returnListFn(pEvent, pLastFocus) {
		iView.show();		
		if (pEvent == Facebook.Define.Update) {
			UpdateCallbackFn(true, pLastFocus);
		}		
		Instance.Main.setKeyHandler(keyHandler,"Stream");
	}

	/** 
	 * Encoding error. New description needed
	 */
	function keyHandler(pKeyCode) {
		if (instanceState == Facebook.Define.Processing) {
			FBTrace("Stream : Processing (Block Key Event)");
			return;
		}
		switch(pKeyCode) {
			case TV.KEY_RIGHT :
			case TV.KEY_PANEL_VOL_DOWN :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.right()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				}
				break;
			case TV.KEY_LEFT :
			case TV.KEY_PANEL_VOL_UP :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.left()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				} else {
					iView.blur(iFocus.getFocus());
					 /* Start Interactive Device */
					if(prevMode == 12 || prevMode == 13 || prevMode == 14 || prevMode == 11){
						iRemoteFB.onLoadFacebook();
						iRemoteFB.onLoadHome();
					}else if(prevMode == 10){
						if (Instance.Frame.getType() == FacebookFrame.Define.ME) {
							iRemoteFB.onLoadFacebook();
						}
						iRemoteFB.onLoadProfile();
					}
					 /* End Interactive Device */
					returnFn();
				}
				break;
			case TV.KEY_UP :
			case TV.KEY_WHEELUP :
			case TV.KEY_PANEL_CH_UP :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.up()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				} else {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				Instance.Main.registHelpNavi(generateHelpNavi(),"Stream");
				Instance.Main.applyHelpNavi("Stream");
				break;
			case TV.KEY_DOWN :
			case TV.KEY_WHEELDOWN :
			case TV.KEY_PANEL_CH_DOWN :
				var oldFocus = { page : iFocus.getFocus().page, row: iFocus.getFocus().row, col: iFocus.getFocus().col };
				if (iFocus.down()) {
					iView.blur(oldFocus);
					iView.focus(iFocus.getFocus());
				} else {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
				}
				Instance.Main.registHelpNavi(generateHelpNavi(),"Stream");
				Instance.Main.applyHelpNavi("Stream");
				break;
			case TV.KEY_FF :
				if (iFocus.nextPage(true)) {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
					Instance.Main.registHelpNavi(generateHelpNavi(),"Stream");
					Instance.Main.applyHelpNavi("Stream");
				}
				break;
			case TV.KEY_RW :
				if (iFocus.prevPage(true)) {
					requestPage(iFocus.getFocus().page);
					iView.focus(iFocus.getFocus());
					Instance.Main.registHelpNavi(generateHelpNavi(),"Stream");
					Instance.Main.applyHelpNavi("Stream");
				}
				break;				
			case TV.KEY_ENTER :
				objPages[iFocus.getFocus().page][iFocus.getFocus().row][iFocus.getFocus().col].actor();
				break;
			case TV.KEY_RETURN : 
				// Return to main menu	
				iView.blur(iFocus.getFocus());
				 /* Start Interactive Device */
				if(prevMode == 12 || prevMode == 13 || prevMode == 14 || prevMode == 11){
					iRemoteFB.onLoadFacebook();
					iRemoteFB.onLoadHome();
				}else if(prevMode == 10){
					if (Instance.Frame.getType() == FacebookFrame.Define.ME) {
						iRemoteFB.onLoadFacebook();
					}
					iRemoteFB.onLoadProfile();
				}
				 /* End Interactive Device */
				returnFn();
				break;
			case TV.KEY_GREEN :
				if (isWhatsOnYourMind()) return;
				instanceState = Facebook.Define.Processing;
				var objStream = iFocus.getFocus().row < 3 ? objPages[iFocus.getFocus().page][1][0].data : objPages[iFocus.getFocus().page][4][0].data;
                (new StreamAddComment(new StreamAddCommentData(), function(pStateChange){
                    UpdateCallbackFn(pStateChange, {postID : objStream.post_id, row : iFocus.getFocus().row, col : iFocus.getFocus().col });
                })).enter(objStream.post_id);
				break;
			default :
				break;
		}
	}
	
	 /* Start Interactive Device */
	fromStreamAddComment = new StreamAddComment(new StreamAddCommentData(), AddCommentReturn);
	function AddCommentReturn(pStateChange){
		UpdateCallbackFn(pStateChange);
	}
	 /* End Interactive Device */
	/** 
	* Encoding error. New description needed
	 */
	function SubmenuCallbackFn(pReturn) {
		Instance.Main.setKeyHandler(keyHandler,"Stream");		
		switch(pReturn) {
			case Facebook.Define.Update :
				Instance.Main.preventKeyEvent(); 
				iData.request(userID, function(pData){
					Instance.Main.releaseKeyEvent();
					OnLoadData(pData, true);
				});
				break;
			default :
				break;
		}
	}
	
	/** 
	 * Encoding error. New description needed
	 */
	function UpdateCallbackFn(pStateChange, pLastFocus) {
		Instance.Main.setKeyHandler(keyHandler,"Stream");
		if (pStateChange || pStateChange == Facebook.Define.Success) {
			iData.request(userID, function(pData){
				OnLoadData(pData, true, pLastFocus);
				/* Start Interactive Device */
	           if(prevMode == 12){
			   	iRemoteFB.onLoadStatusUpdate(pData.result);
			   }else if(prevMode == 13){
			   	iRemoteFB.onLoadPhotos(pData.result);
			   }else if(prevMode == 14){
			   iRemoteFB.onLoadVidoes(pData.result);
			   }else if(prevMode == 11){
			   	iRemoteFB.showNews(pData.result,iRemoteFB.GlobalMode);
			   }else if(prevMode == 10){
			   iRemoteFB.showWall(pData.result,iRemoteFB.GlobalMode);
			   }					
	           /* End Interactive Device */

			});
		} else {
            /* Start Interactive Device */
           if(prevMode == 12){
		   	iRemoteFB.onLoadStatusUpdate(NewsFeedArray);
		   }else if(prevMode == 13){
		   	iRemoteFB.onLoadPhotos(NewsFeedArray);
		   }else if(prevMode == 14){
		   iRemoteFB.onLoadVidoes(NewsFeedArray);
		   }else if(prevMode == 11){
		   	iRemoteFB.showNews(NewsFeedArray,iRemoteFB.GlobalMode);
		   }else if(prevMode == 10){
		   iRemoteFB.showWall(NewsFeedArray,iRemoteFB.GlobalMode);
		   }					
           /* End Interactive Device */
		   instanceState = Facebook.Define.None;           
		}
     }
this.updateCallbackFn = function(pStateChange){
//var objStream = iFocus.getFocus().row < 3 ? objPages[iFocus.getFocus().page][1][0].data : objPages[iFocus.getFocus().page][4][0].data;
UpdateCallbackFn(pStateChange, {postID : NOpostID, row : iFocus.getFocus().row, col : iFocus.getFocus().col });
/*Instance.Main.setKeyHandler(keyHandler,"Stream");
if (pStateChange || pStateChange == Facebook.Define.Success) {
			iData.request(userID, function(pData){
				OnLoadData(pData, false, pLastFocus);
			});
		} else {
			instanceState = Facebook.Define.None;
		}*/
}
	/** 
	 * Encoding error. New description needed
	 */
	function ShareCallbackFn(pResult) {
		Instance.Main.setKeyHandler(keyHandler,"Stream");
		switch(pResult) {
			case Facebook.Define.Success : 
				iData.request(userID, function(pData){
					OnLoadData(pData, true);
					/* Start Interactive Device */
	           if(prevMode == 12){
			   	iRemoteFB.onLoadStatusUpdate(pData.result);
			   }else if(prevMode == 13){
			   	iRemoteFB.onLoadPhotos(pData.result);
			   }else if(prevMode == 14){
			   iRemoteFB.onLoadVidoes(pData.result);
			   }else if(prevMode == 11){
			   	iRemoteFB.showNews(pData.result,iRemoteFB.GlobalMode);
			   }else if(prevMode == 10){
			   iRemoteFB.showWall(pData.result,iRemoteFB.GlobalMode);
			   }					
	           /* End Interactive Device */
				});
			default :
				instanceState = Facebook.Define.None;
				break;
		}
	}
	
	/** 
	 * Encoding error. New description needed
	 */
	function FilterCallbackFn(pFilter) {
		Instance.Main.setKeyHandler(keyHandler,"Stream");
		changeFilter(pFilter);
	}
	
	function changeFilter(pFilter) {
		if (!objTotalStream) return false;
		if (pFilter == Stream.Define.All) {
			currentFilter = pFilter;
			generatePage(objTotalStream);
		} else if (pFilter == Stream.Define.Text || pFilter == Stream.Define.Photo || pFilter == Stream.Define.Video){
			currentFilter = pFilter;
			generatePage(objTotalStream, pFilter);
		}
		
		iFocus.generate(objPages);
		iFocus.setPage(0);
		iFocus.resetFocus();
		requestPage(iFocus.getFocus().page);
		
		if (Instance.Main.getKeyHandler() == "Stream") {
			Instance.Main.applyHelpNavi("Stream");
		}
		
		if(objPages[0].length > 0) 
			return true;
		else
			return false;
	}
	
	/** 
	 * Encoding error. New description needed
	 */
	function countFilteredStream(pData, pFilter) {
		var dataLength = pData.length;
		var curStream = null;
		var nStreamType = null;
		var nCount = 0;
		
		for (var dataIdx = 0; dataIdx < dataLength; dataIdx++) {
			curStream = pData[dataIdx];
			nStreamType = Stream.Common.getStreamType(curStream);
			if (pFilter == Stream.Define.Photo) {
				if (nStreamType == Stream.Define.Photo || nStreamType == Stream.Define.Album) {
					nCount++;
				}
			}
			else {
				if (nStreamType == pFilter) {
					nCount++;
				}
			}
		}
		
		return nCount;
	}

	/** 
	 * Encoding error. New description needed
	 * @param		pResult		Event type
	 */
	function StreamYourMindReturnFn(pResult, pPostID) {
		Instance.Main.setKeyHandler(keyHandler,"Stream");		
		if (pResult == Facebook.Define.Update) {
			iFocus.setPage(0);
			Instance.Main.preventKeyEvent();
			
			iData.checkUpdate(pPostID, function() {
				iData.request(userID, function(pData){
					Instance.Main.releaseKeyEvent();
					OnLoadData(pData, true, Stream.Define.RESET);
					/* Start Interactive Device */				
	           if(prevMode == 12){
			   	iRemoteFB.onLoadStatusUpdate(pData.result);
			   }else if(prevMode == 13){
			   	iRemoteFB.onLoadPhotos(pData.result);
			   }else if(prevMode == 14){
			   iRemoteFB.onLoadVidoes(pData.result);
			   }else if(prevMode == 11){
			   	iRemoteFB.showNews(pData.result,iRemoteFB.GlobalMode);
			   }else if(prevMode == 10){
			   iRemoteFB.showWall(pData.result,iRemoteFB.GlobalMode);
			   }					
	           /* End Interactive Device */
					
				});				
			});
		} else if (pResult == Facebook.Define.Cancel) {
			instanceState = Facebook.Define.None;
		} else {
			instanceState = Facebook.Define.None;
		}
	}
	
	function isWhatsOnYourMind() {
		var curFocus = iFocus.getFocus();
		if (objPages[curFocus.page]) {
			if (objPages[curFocus.page][curFocus.row]) {
				if (objPages[curFocus.page][curFocus.row][curFocus.col]) {
					if (objPages[curFocus.page][curFocus.row < 3 ? 0 : 3][0].data == Facebook.Define.ItemType.ACTOR) {
						FBTrace("isWhatsOnYourMind -> true : " + objPages[curFocus.page][curFocus.row < 3 ? 0 : 3][0].data);
						return true;
					}
				}
			}
		}
		FBTrace("isWhatsOnYourMind -> false");
		return false;
	}
}

Stream.Define = {};
Stream.Common = {};

Stream.Define.All = 0;
Stream.Define.Text = 1;
Stream.Define.Photo = 2;
Stream.Define.Album = 3;
Stream.Define.Video = 4;
Stream.Define.Link = 5;
Stream.Define.Unknown = 9;

Stream.Define.WALL = 10;
Stream.Define.NEWSFEED = 11;
Stream.Define.STATUS_UPDATES = 12;
Stream.Define.PHOTOS = 13;
Stream.Define.VIDEOS = 14;
Stream.Define.FRIENDS_REQUEST = 15;

Stream.Define.RESET = 99;

Stream.Common.getStreamType = function(pStream) {
	if (!Util.isEmptyObject(pStream.app_data) && !Util.isEmptyObject(pStream.app_data.attachment_data)) {
		var objAppAttachment = Util.DecodeJSON(pStream.app_data.attachment_data);
		if (objAppAttachment.share && objAppAttachment.media && objAppAttachment.media instanceof Array) {
			pStream.attachment.fb_object_type = objAppAttachment.media[0].type;
			pStream.attachment.media = objAppAttachment.media;
			pStream.share = true;
		}
	}

//	if (!Util.isEmptyObject(pStream.attachment) && !Util.isEmptyObject(pStream.attachment.media) && pStream.attachment.fb_object_type != "") {
	// ###@@@
	if (!Util.isEmptyObject(pStream.attachment) && !Util.isEmptyObject(pStream.attachment.media)) {
		if (pStream.attachment.media && pStream.attachment.media instanceof Array && pStream.attachment.media[0].type == "link") return Stream.Define.Link
		if (pStream.attachment.fb_object_type == "photo" || pStream.attachment.fb_object_type == "image") {
			return Stream.Define.Photo;
		} else if (pStream.attachment.fb_object_type == "video"){
			return Stream.Define.Video;
		} else if (pStream.attachment.fb_object_type == "album") {
			return Stream.Define.Album;
		} 
	} else if (pStream.message != "" && (Util.isEmptyObject(pStream.attachment) || Util.isEmptyObject(pStream.attachment.media)) && !pStream.attachment.fb_object_type){
		return Stream.Define.Text;
	} 
//	else if (pStream.attachment.media instanceof Array && pStream.attachment.media[0].type == "video") {
//		return Stream.Define.Video;
//	}
	else {
		return Stream.Define.Unknown;
	}
}