function StreamAddComment(pDataInstance, pReturnFn) {
	var _this_ = this;
	
	var iData = pDataInstance;
	var returnFn = pReturnFn;
	var objectID = null;
	var bUserVID = false;
	
	this.enter = function(pPostID) {
		objectID = pPostID;
		bUserVID = false;
		Instance.Multiline.open(SID_COMMNET_M_ADD_COMMENT, "", returnControl);
	}
	
	this.enterVID = function(pVID) {
		objectID = pVID;
		bUserVID = true;
		Instance.Multiline.open(SID_COMMNET_M_ADD_COMMENT, "", returnControl);		
	}
	
	function returnControl(pResult) {
		if (pResult) {			
			if (bUserVID) {				
				iData.requestVID(objectID, pResult, AddCommentCallback);				
			} else {
				iData.request(objectID, pResult, AddCommentCallback);
			}
		} else {
			returnFn(pResult);			
		}
		facebookKeyHandler.focus();
	}
	
	this.returnControl = function(pResult, PpostID){
		objectID = PpostID;		
		returnControl(pResult);
	}
	
	function AddCommentCallback(pResult) {
		returnFn(pResult);
	}
	
	function keyHandler(pKeyCode) {
		switch(pKeyCode) {
			case TV.KEY_RIGHT :
			case TV.KEY_PANEL_VOL_DOWN :
				break;
			case TV.KEY_LEFT :
			case TV.KEY_PANEL_VOL_UP :
				break;
			case TV.KEY_UP :
			case TV.KEY_WHEELUP :
			case TV.KEY_PANEL_CH_UP :
				break;
			case TV.KEY_DOWN :
			case TV.KEY_WHEELDOWN :
			case TV.KEY_PANEL_CH_DOWN :
				break;
			case TV.KEY_FF :
				break;
			case TV.KEY_RW :
				break;				
			case TV.KEY_ENTER :
				break;
			case TV.KEY_RETURN : 
				break;
			default :
				break;
		}
	}
}