function StreamDeleteData() {
	var params = null;
    var completeFn = null;

    this.request = function(pParams, pCompleteFn){
		Instance.Loading.open();
        /*Start Interactive Device */
        iRemoteFB.showLoading("Loading Data");
        /* End Interactive Device */
		params = pParams;
        completeFn = pCompleteFn;
        
        Instance.API.stream.remove(function(pXMLHttpRequest){
            OnLoadData(pXMLHttpRequest);
        }, Instance.API.createAPIParams({
            post_id: pParams,
            format: "JSON"
        }));
        
    }
    function OnLoadData(pXMLHttpRequest){

        if (!Instance.Main.checkNetworkError(pXMLHttpRequest)) return;
		
		FBTrace(pXMLHttpRequest.responseText);
        var objResponse = Util.DecodeJSON(pXMLHttpRequest.responseText);
		
		Instance.Loading.close();
        /* Start Interactive Device */
		iRemoteFB.hideLoading();
        /* End Interactive Device */
		if (objResponse === true) {
	        completeFn(Facebook.Define.Success);
		} else if (objResponse.error_code) {
			FBTrace_("error_code : "+objResponse.error_code);
			FBTrace_("error_msg : "+objResponse.error_msg);
			completeFn(Facebook.Define.Fail);
		}
    }
}

/*
 *  { "error_code": 200, "error_msg": "This post wasn't created by the application" }
 */