function StreamVideoFullView(pObjDiv) {
	var objDiv = pObjDiv;
	objDiv = pObjDiv;
	objDiv.style.position = "absolute";
	objDiv.style.left = "0px";
	objDiv.style.top = "0px";
	objDiv.style.width = "960px";
	objDiv.style.height = "540px";
//	objDiv.style.display = "none";
	objDiv.style.visibility = "hidden";

	var objVolumeDiv = null;
	var objVolumeIconDiv = null;
	var strVolumeDiv = "_StreamVideoFullView_Volume_";
	var strVolumeIconDiv = "_StreamVideoFullView_VolumeIcon_";

	var iFocus = null;
	
	this.show = function() {
//		objDiv.style.display = "block";
		objDiv.style.visibility = "visible";
		Instance.Main.showBlankPage();
		_$("facebookHelpDiv").style.backgroundImage = "url(Resource/images/navi_help_bg02.png)";
	}

	this.hide= function() {
		Instance.Main.hideBlankPage();
//		objDiv.style.display = "none";		
		objDiv.style.visibility = "hidden";
		_$("facebookHelpDiv").style.backgroundImage = "url(Resource/images/navi_help_bg.png)";
		Instance.GMF.BDFrontPanelDisplay(FRONT_DISPLAY_ONLINE);
	}
	
	this.request = function(pVideo) {
		WIDGET.putInnerHTML(objDiv, generateHTML(pVideo));

		// Display volume
//		this.setVolumeOSD();
		this.setStatus(Instance.GMF.getState());
	}
	
	this.setStatus = function(pStatus) {
		switch(pStatus) {
			case GMFPlayer.PLAYING :
				_$("_StreamVideoFullView_Play_Status_").style.backgroundImage = "url(Resource/images/profile_video_play02.png)";
				Util.ScreenSaver.off();
				Instance.GMF.BDFrontPanelDisplay(FRONT_DISPLAY_PLAY);
				break;
			case GMFPlayer.STOPPED : 
				_$("_StreamVideoFullView_Play_Status_").style.backgroundImage = "url(Resource/images/help_stop.png)";
				Util.ScreenSaver.on();
				Instance.GMF.BDFrontPanelDisplay(FRONT_DISPLAY_STOP);
				break;
			case GMFPlayer.PAUSED :
				_$("_StreamVideoFullView_Play_Status_").style.backgroundImage = "url(Resource/images/profile_video_pause02.png)";
				Util.ScreenSaver.on();
				Instance.GMF.BDFrontPanelDisplay(FRONT_DISPLAY_PAUSE);
				break;
		}
	}
	
	var divCurrentTime = null;
	var divTotalTime = null;
	
	this.setTime = function(pTime) {
		divCurrentTime = _$("_StreamVideoFullView_Play_Time_");
		if (divCurrentTime) {
			var objTime = Util.getSeperateTime(Math.round(pTime / 10) * 10); // Round-up(1th)
			divCurrentTime.innerHTML = objTime.hour + ":" + objTime.min + ":" + objTime.sec;
			Instance.GMF.BDFrontPanelTime(parseInt(objTime.hour, 10), parseInt(objTime.min, 10), parseInt(objTime.sec, 10));
		}
	}
	
	this.setTotalTime = function(pTime) {
		divTotalTime = _$("_StreamVideoFullView_Total_Time_");
		if (divTotalTime) {
			var objTime = Util.getSeperateTime(Math.round(pTime / 10) * 10); // Round-up(1th)
			divTotalTime = _$("_StreamVideoFullView_Total_Time_");
			divTotalTime.innerHTML = objTime.hour + ":" + objTime.min + ":" + objTime.sec;
		}
	}

	this.setVolumeOSD = function() {
		objVolumeDiv = _$(strVolumeDiv);
		objVolumeIconDiv = _$(strVolumeIconDiv);
		
		objVolumeDiv.style.visibility = "visible";
		objVolumeIconDiv.style.visibility = "visible";
		
		if (Instance.Audio.getMute()) {
			objVolumeDiv.innerHTML = "";
			objVolumeIconDiv.src = "Resource/images/mute_icon.png";

			if (StreamVideoFullView.instanceTimer) clearTimeout(StreamVideoFullView.instanceTimer);
		}
		else {
			objVolumeDiv.innerHTML = Instance.Audio.getVolume();
			objVolumeIconDiv.src = "Resource/images/volume_icon.png";

			if (StreamVideoFullView.instanceTimer) clearTimeout(StreamVideoFullView.instanceTimer);
			StreamVideoFullView.instanceTimer = setTimeout(function(){
				objVolumeDiv.style.visibility = "hidden";
				objVolumeIconDiv.style.visibility = "hidden";
			},1000)
		}
	}

	this.showHelpNavi = function() {
		Instance.Main.showHelpNavi();
		var tObj = _$("_facebook_StreamVideoFullView_Help_");
		if (tObj) tObj.style.visibility = "visible";
	}
	
	this.hideHelpNavi = function() {
		Instance.Main.hideHelpNavi();
		var tObj = _$("_facebook_StreamVideoFullView_Help_");
		if (tObj) tObj.style.visibility = "hidden";
	}

	var Style = {
		Header : {left:"0px",top:"0px", width : "960px", height : "48px" },
		Play : { left:"57px",top:"12px", width : "10px", height : "15px", 'background-image' : "url(Resource/images/profile_video_play02.png)" },
		TotalTime : {left:"582px",top:"12px",width:"200px",height:"30px",color:"#FFFFFF",font:"",'text-align':"left"},
		CurTime : {left:"161px",top:"12px",width:"200px",height:"30px",color:"#FFFFFF",font:"",'text-align':"left"},
		Filename : { left : "723px", top : "12px", width : "200px", height : "35px", 'text-align' : "center",color:"#FFFFFF",font : "16px",'padding-right' : "5px",'overflow': 'hidden','white-space':'nowrap','text-overflow':"ellipsis"},
		VolumeIcon : {left:"665px",top:"12px",width:"14px",height:"15px",visibility : "hidden"},
		VolumeNum : {left:"671px",top:"12px",width:"50px",height:"30px",color:"#FFFFFF",font:"16px bold",'text-align':"center",visibility : "hidden"}
	}
	
	function generateHTML(pVideo) {
		var strHTML = "";
		strHTML += "<div id = '_facebook_StreamVideoFullView_Help_' style = 'position:absolute;left:0px;top:0px;width:960px;height:540px;'>"
		strHTML += Util.addImage(Util.getStyle(Style.Header),"Resource/images/fullscreen_bg02.png");
		strHTML += Util.addDiv(Util.getStyle(Style.Play),"","_StreamVideoFullView_Play_Status_");
		strHTML += Util.addDiv(Util.getStyle(Style.Filename),(pVideo.name != "") ? pVideo.name : SID_NO_TITLE_PHOTOS);
		strHTML += Util.addDiv(Util.getStyle(Style.CurTime),"","_StreamVideoFullView_Play_Time_");
		strHTML += Util.addDiv(Util.getStyle(Style.TotalTime),Util.moldTime(pVideo.length),"_StreamVideoFullView_Total_Time_");
		strHTML += Util.addImage(Util.getStyle(Style.VolumeIcon),Instance.Audio.getMute() ? "Resource/images/mute_icon.png":"Resource/images/volume_icon.png",strVolumeIconDiv);
		strHTML += Util.addDiv(Util.getStyle(Style.VolumeNum),Instance.Audio.getMute()?"":Instance.Audio.getVolume(),strVolumeDiv);
		strHTML += "</div>";

//		FBTrace(strHTML);
		return strHTML;
	}
}

StreamVideoFullView.instanceTimer = null;